#ifndef OEMFEATURES_H
#define OEMFEATURES_H
/*======================================================
FILE:  OEMFeatures.h

SERVICES:  AEE Features

GENERAL DESCRIPTION:
   Temporary file.  Compiler options for AEE

        Copyright ?1999-2002 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/
#if defined AEE_SIMULATOR
#include "BREWSimFeatures.h"  // Simulator Feature Definitions
#else
#if defined(CUST_H) || defined(CUSTFILE) || defined(CUSTH)
#include "customer.h"         //Handset Feature Definitions
#endif
#endif


//
// The following defines are used to selectively compile the OEM_XXXX.c
// routines.  If these flags are DEFINED, then we will compile the OEM_XXXX.c
// versions provided as samples.
//

#if !defined(OEMDB)
   #define OEMDB               // Use OEMDB.c
#endif

#if !defined(OEMAPPFUNCS)
   //#define OEMAPPFUNCS         // Use OEMAppFuncs.c
#endif //

#if !defined(OEMSTRINGFUNCS)
   //#define OEMSTRINGFUNCS      // Use OEMStringFuncs.c
#endif

#if !defined(OEMHEAP)
   //#define OEMHEAP             // Use OEMHeap.c
#endif

#if !defined(OEMDISP)
   //#define OEMDISP             // Use OEMDisp.c
#endif

#if !defined(OEMTEXT)
   //#define OEMTEXT             // Use OEMText.c
#endif

#if !defined(OEMSMS)
   //#define OEMSMS              // Use OEMSMS.c
#endif

#if !defined(OEMPRIVACY)
   #define OEMPRIVACY            // Use OEMPrivacy.c
#endif

#if !defined(OEMRINGERS)
   #define OEMRINGERS            // Use OEMRingers.c
#endif

#if !defined(OEMPROVISION)
   #define OEMPROVISION          // Use OEMProvision.c
#endif

#if !defined(FEATURE_CALLHISTORY)
   #define FEATURE_CALLHISTORY   // Use OEMCallHistory.c
#endif

// ZiCorp Simplified Chinese Stroke mode
//#define FEATURE_ZICORP_STROKE // Use OEMIMM.c and OEMIMUI.c
// ZiCorp Simplified Chinese Pinyin mode
//#define FEATURE_ZICORP_PINYIN // Use OEMIMM.c and OEMIMUI.c

// These enable the default language to be specified in 
// the text control when AEE_TM_EZTEXT is given
// This is not the full integration of the specified language
// To do that a new mode would need to be added for the multitap
// in that language.
// Optionally you would support the AEE_TM_*_R mode to let the user
// specify the language rapid mode needed.
//#define FEATURE_ZICORP_EZI_EN // Enables eZi English
//#define FEATURE_ZICORP_EZI_TH // Enables eZi Thai
//#define FEATURE_ZICORP_EZI_IT // Enables eZi Italian
//#define FEATURE_ZICORP_EZI_FR // Enables eZi French
//#define FEATURE_ZICORP_EZI_BP // Enables eZi Brasilian Portuguese
//#define FEATURE_ZICORP_EZI_PR // Enables eZi Portuguese
//#define FEATURE_ZICORP_EZI_ES // Enables eZi Spanish

// No need to modify this block, it depends on the features above
#if defined(FEATURE_ZICORP_EZI_EN) || defined(FEATURE_ZICORP_EZI_TH) \
    || defined(FEATURE_ZICORP_EZI_IT) || defined(FEATURE_ZICORP_EZI_FR) \
    || defined(FEATURE_ZICORP_EZI_BP) || defined(FEATURE_ZICORP_EZI_PR) \
    || defined(FEATURE_ZICORP_EZI_ES) 
#define FEATURE_ZICORP_EZITEXT // ZiCorp eZiText needed
#endif

// No need to modify this block, it depends on the features above
#if defined(FEATURE_ZICORP_STROKE) || defined(FEATURE_ZICORP_PINYIN) // {
#define FEATURE_ZICORP_CHINESE   // A ZiCorp Chinese method is selected
#ifndef FEATURE_BREW_IME // {
#define FEATURE_BREW_IME         // IME support for Chinese mode
#endif // } !FEATURE_BREW_IME
#endif // } FEATURE_ZICORP_STROKE || FEATURE_ZICORP_PINYIN

// You must include "ViewApp.c" in the build for this to be enabled.

//#define FEATURE_DEFAULT_VIEW_APP  // Use ViewApp.c as default view applet.

// Use the largest heap possible
#define FEATURE_DYNAMIC_OEM_HEAP

#if defined(OEMHEAP) && !defined(OEM_STATIC_HEAP_SIZE) && !defined(AEE_SIMULATOR)
#define OEM_STATIC_HEAP_SIZE  81920  /* 80K */
#endif

//
// Linked AEE Libraries...
//

#define AEEBTIL_LIB     1
#define AEEMENU_LIB     1
#define AEECONTROLS_LIB 1
#define AEEDB_LIB       1

//
// Feature Libraries
//
#if defined (FEATURE_XML)
   #define AEEXML_LIB      1
#endif

#if defined(FEATURE_CM)
  #define FEATURE_BREW_TAPI 1
#endif

#if defined(FEATURE_DS_SOCKETS)
   #define AEENET_LIB      1
#endif

#if defined(FEATURE_AUDIO_FORMAT) || defined(FEATURE_VOICE_MEMO)
   #define FEATURE_SOUNDPLAYER  1
#endif

#define FEATURE_BTIL       1

#define FEATURE_BREW_SOUND 1

#define FEATURE_GRAPHICS   1

#if defined(FEATURE_AUDIO_FORMAT) || defined(FEATURE_MIDI_OUT)
#define FEATURE_BREW_MULTIMEDIA
#endif // defined(FEATURE_AUDIO_FORMAT) || defined(FEATURE_MIDI_OUT)

#if defined(FEATURE_BREW_MULTIMEDIA)
#define OEMOBJECTMGR
#endif // defined(FEATURE_BREW_MULTIMEDIA)

#define FEATURE_HTMLVIEWER

#define FEATURE_POSITION_DETERMINATION

#define FEATURE_BREW_FONTS

#define FEATURE_BREW_APPFRAME

#define FEATURE_BREW_BITMAPDEV

#ifdef FEATURE_VOC_PACKET_INTERFACE
#define FEATURE_IVOCODER
#endif

#ifdef FEATURE_MVS
#define VOCODER_USES_MVS
#endif

#define FEATURE_BREW_SECURITY       // turn on hashes, ciphers and random numbers
#define FEATURE_BREW_RSA            // Turn on RSA; needed for sig verify, SSL & IX509Chain
#if defined(FEATURE_BREW_SECURITY)
//   #define FEATURE_BREW_DES3DES     // define this to turn on DES and 3DES in BREW
#endif


#define FEATURE_BREW_SSL            // turn on BREW SSL
#define FEATURE_BREW_SSLROOTCERTS   // turn on BREW SSL Root Certificates

#define FEATURE_BREW_ROOTCERTS // Turn on WebOpts based access to root certs

#define FEATURE_BREW_RAMCACHE
#define FEATURE_BREW_SPRITE

#define  FEATURE_LOGGER_FILE
#define  FEATURE_LOGGER_WIN
#ifdef FEATURE_BREW_SIO
#define  FEATURE_LOGGER_SERIAL
#endif
#define  FEATURE_LOGGER_BTIL
#if defined(FEATURE_LOGGER_FILE) || defined(FEATURE_LOGGER_SERIAL) || defined(FEATURE_LOGGER_DMSS) || defined(FEATURE_LOGGER_WIN) || defined(FEATURE_LOGGER_BTIL)
#define  FEATURE_LOGGER
#endif

#define FEATURE_BREW_KEYMAKER

// Enable Top Visible Application Priorities
#define FEATURE_TOPVISIBLE

#if defined FEATURE_UIM
//#define FEATURE_IRUIM
#define FEATURE_ADDRBOOK_RUIM
#endif

//Enable the following definition to include GSM1x support.
//#define FEATURE_GSM1x

#define FEATURE_BREW_SMS 1

#define FEATURE_BREW_RESCTL

#define FEATURE_BREW_SCALE       // turn on image scaling in BREW viewers

#define FEATURE_DEV_NOTIFIER

#define FEATURE_BREW_NETMTPDNOTIFIER

#define FEATURE_BREW_QOS

#endif   // OEMFEATURES_H
