/*======================================================
FILE:  OEMModTableExt.c

SERVICES:  Reference OEM specific Static Module/Class Tables.

GENERAL DESCRIPTION:
   This file contains the list of static modules and static classes
   that are specific to OEM platform. These get included as part of
   the static tables defined in OEMModTable.c.

PUBLIC CLASSES AND STATIC FUNCTIONS:
   List the class(es) and static functions included in this file

INITIALIZATION & SEQUENCING REQUIREMENTS:

   See Exported Routines

        Copyright  1999-2002 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/
#include "OEMFeatures.h"
#include "OEMModTableExt.h"

/* =====================================================
   Statically linked application list.
=====================================================*/
static const AEEStaticMod gOEMStaticModList[] = 
{ 
   {NULL, NULL}
};

/* =====================================================
   statically linked list of lists of AEEStaticApp
=====================================================*/
const AEEStaticMod *gOEMStaticModLists[] = { 
   gOEMStaticModList,
   NULL
};

/* =====================================================
   Statically linked class list.
=====================================================*/
static const AEEStaticClass gOEMStaticClassList[] = {
   {0,0,0,NULL,NULL}
};

/* =====================================================
   statically linked list of lists of AEEStaticClasses
=====================================================*/
const AEEStaticClass *gOEMStaticClassLists[] = { 
   gOEMStaticClassList,
   NULL
};

/* =====================================================
   Statically linked k class list.
=====================================================*/
static const AEEkStaticClass gOEMkStaticClassList[] = {
   {0,0,},
};

/* =====================================================
   statically linked list of lists of AEEkStaticClasses
=====================================================*/
const AEEkStaticClass *gOEMkStaticClassLists[] = { 
   gOEMkStaticClassList,
   NULL
};

