/*======================================================
FILE:  bridle_GSM1xSIG.c

SERVICES:  BRIDLE SWI Handler for GSM1xSIG.

GENERAL DESCRIPTION:
   Implements the supervisor mode handler for BRIDLE GSM1xSIG

PUBLIC CLASSES AND STATIC FUNCTIONS:

INITIALIZATION & SEQUENCING REQUIREMENTS:

   See Exported Routines

        Copyright  1999-2003 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/
#include "BRIDLEInit.h"
#include "OEMFeatures.h"
#if defined(FEATURE_GSM1x)

#define _BRIDLE_GSM1XSIG_IMPL
#include "bridle_GSM1xSIG.h"
#include "AEEBRIDLE.h"

#if __ARMCC_VERSION >= 120000
#pragma arm section zidata = "bridle_svc_rw_usr_ro"
#endif
uint32 bridle_oemGSM1xSig_swi;
#if __ARMCC_VERSION >= 120000
#pragma arm section zidata
#endif


/* List of handlers that patch calls to actual routines. The order 
** corresponds to the subroutine ids enumerated in the enum in bridle_GSM1xSIG.h */
static const PFNSWIHANDLER gPtrTable[BRIDLE_GSM1XSIG_MAX] = { 
   (PFNSWIHANDLER)unpackbridle_OEMGSM1xSig_SVC_Init,
   (PFNSWIHANDLER)unpackbridle_OEMGSM1xSig_SVC_GetSIGMessage,
   (PFNSWIHANDLER)unpackbridle_OEMGSM1xSig_SVC_SendSignalingSMS
};

/*===========================================================================

FUNCTION   
   bridle_GSM1xSIG_swihandler

DESCRIPTION
   Invokes the appropriate unpack routine and passes its arguments.
  
DEPENDENCIES
   This is invoked by SWI handler.

RETURN VALUE

SIDE EFFECTS

===========================================================================*/
uint32 bridle_GSM1xSig_swihandler( uint32 arg1, uint32 arg2, uint32 arg3, uint32 arg4, uint32 arg5 )
{
   return bridle_generic_swihandler( arg1, arg2, arg3, arg4, arg5, 
                                     BRIDLE_GSM1XSIG_MAX, gPtrTable );
}

/*===========================================================================

FUNCTION   
   RegisterGSM1xSIGForSWI

DESCRIPTION
   Registers with SWI handler and obtains ID for GSM1xSIG Module.
  
DEPENDENCIES

RETURN VALUE

SIDE EFFECTS

===========================================================================*/
int RegisterGSM1xSIGForSWI(void *po)
{
   return bridle_RegisterSubSystem( bridle_GSM1xSig_swihandler, &bridle_oemGSM1xSig_swi );
}
#endif // FEATURE_GSM1x
