// -----------------------------------------------------------
//		iautolog.h
// -----------------------------------------------------------
#ifndef _IAUTOLOG_H_
#define _IAUTOLOG_H_


// -----------------------------------------------------------
//		include
// -----------------------------------------------------------

#include "AEE.h"
#include "AEEModGen.h"						// Module interface definitions
#include "AEEAppGen.h"						// Applet interface definitions
#include "AEEShell.h"						// Shell interface definitions
#include "AEEHtmlViewer.h"					// HtmlViewer interface definitions
#include "AEEFile.h"						// File interface definitions
#include "AEEHeap.h "						// Heap interface definitions
#include "AEEStdLib.h"						// StdLib defitions
#include "AEEError.h"						// AEE Error Codes
#include "KDDIError.h"						// KDDI Error Codes
#include "iautolog.bid"						// {AvBIDt@C


// -----------------------------------------------------------
//		define
// -----------------------------------------------------------
#define		LOGDIRECTRY			"log/"		//	Ot@C̖O
#define		FREE_SIZE			(20)		//  q[v̈̋󂫃TCY
#define		FILE_BOX			(5)			//	Ǘt@C̐
#define		SHORT_BUFFER		(64)		//	obt@TCY()
#define		MIDDLE_BUFFER		(128)		//	obt@TCY()
#define		LARGE_BUFFER		(256)		//	obt@TCY()
#define		SEEK_POINT			(37)		//	Loggerɂĕ\(1s)(ݒl-1\)


// -----------------------------------------------------------
//		Private Error Codes
// -----------------------------------------------------------
#define		IAUTOLOG_ERROR_BASE			(0x5000)
#define		IAUTOLOG_SUCCESS			(SUCCESS)					//	
#define		IAUTOLOG_EFAILED			(IAUTOLOG_ERROR_BASE + 1)	//	s
#define		IAUTOLOG_EBADPARM			(IAUTOLOG_ERROR_BASE + 2)	//	p[^s
#define		IAUTOLOG_ENOMEMORY			(IAUTOLOG_ERROR_BASE + 3)	//	IAUTOLOG_ENOMEMORY
#define		IAUTOLOG_ECLASS				(IAUTOLOG_ERROR_BASE + 4)	//	IAUTOLOGC^[tF[X
																	//	gpĂCX^X̍쐬s
#define		IAUTOLOG_EDIRECTRY			(IAUTOLOG_ERROR_BASE + 5)	//	OǗfBNgɊւ鏈̎s
#define		IAUTOLOG_EFILE				(IAUTOLOG_ERROR_BASE + 6)	//	Ot@CɊւ鏈̎s


// -----------------------------------------------------------
//		Interface
// -----------------------------------------------------------
typedef  struct  _IAutoLog				IAutoLog ;

QINTERFACE(IAutoLog)
{

	//	IBASĚp
	DECLARE_IBASE(IAutoLog)

	int			( *MemoryCheck		)	( IAutoLog  *p );
	int			( *Management		)	( IAutoLog  *p, const char *szFilename );
	uint32		( *FileWrite		)	( IAutoLog  *p, boolean Flag, const char *pszFormat, ... );
	int			( *Main				)	( IAutoLog  *p, IHtmlViewer *pIHTMLViewer, uint32 nCase );
	int			( *Debug			)	( IAutoLog  *p, IHtmlViewer *pIHTMLViewer, HViewNotify *pHViewNotify );

	void		( *ErrorCheck		)	( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
	void		( *BTErrorCheck		)	( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
	void		( *KDDIErrorCheck	)	( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
	void		( *FILEErrorCheck	)	( IAutoLog  *p, IFileMgr * pIFileMgr, char *pError, uint32 nSize );
	void		( *AUTOErrorCheck	)	( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
	void		( *GetParam			)	( IAutoLog  *p, const char  *pszData, const char *element, char *pszBuffer, uint16  nBufSize );

} ;




// -----------------------------------------------------------
//		Function macroscopic definition
// -----------------------------------------------------------

#define		IAUTOLOG_AddRef( p )							GET_PVTBL( p, IAutoLog )->AddRef( p ) 
#define		IAUTOLOG_Release( p )							GET_PVTBL( p, IAutoLog )->Release( p ) 
#define		IAUTOLOG_MemoryCheck( p )						GET_PVTBL( p, IAutoLog )->MemoryCheck( p ) 
#define		IAUTOLOG_Management( p, ps )					GET_PVTBL( p, IAutoLog )->Management( p, ps ) 
#define		IAUTOLOG_FileWrite( p, args )					GET_PVTBL( p, IAutoLog )->FileWrite args
#define		IAUTOLOG_Main( p, ph, n )						GET_PVTBL( p, IAutoLog )->Main( p, ph, n )
#define		IAUTOLOG_Debug( p, ph, pn )						GET_PVTBL( p, IAutoLog )->Debug( p, ph, pn )

#define		IAUTOLOG_ErrorCheck( p, n, ps, un )				GET_PVTBL( p, IAutoLog )->ErrorCheck( p, n, ps, un )	
#define		IAUTOLOG_BTErrorCheck( p, n, ps, un )			GET_PVTBL( p, IAutoLog )->BTErrorCheck( p, n, ps, un )	
#define		IAUTOLOG_KDDIErrorCheck( p, n, ps, un )			GET_PVTBL( p, IAutoLog )->KDDIErrorCheck( p, n, ps, un )
#define		IAUTOLOG_FILEErrorCheck( p, pf, ps, un )		GET_PVTBL( p, IAutoLog )->FILEErrorCheck( p, pf, ps, un )	
#define		IAUTOLOG_AUTOErrorCheck( p, n, ps, un )			GET_PVTBL( p, IAutoLog )->AUTOErrorCheck( p, n, ps, un )
#define		IAUTOLOG_GetParam( p, ps1, ps2, ps3, un )		GET_PVTBL( p, IAutoLog )->GetParam( p, ps1, ps2, ps3, un )


/*======================================================================================

	֐	: uint32	IAUTOLOG_AddRef( IAutoLog *p )
		: QƃJE^̃CNg
----------------------------------------------------------------------------------------
	߂l	: IuWFNg̃CNgꂽQƃJEg

		: IAutoLog		 *p				| IAutoLogC^tF[XIuWFNgւ̃|C^


======================================================================================== 

  	֐	: uint32	IAUTOLOG_Release( IAutoLog *p )
		: QƃJE^̃fNg
---------------------------------------------------------------------------------------
	߂l	: IuWFNg̃fNgꂽQƃJEg
			  0i[j́AIuWFNg[ĖɂȂꍇ

		: IAutoLog		 *p				| IAutoLogrC^tF[XIuWFNgւ̃|C^


=======================================================================================

  	֐	: int	 IAUTOLOG_MemoryCheck( IAutoLog  *p )
		: q[v̈̃[󂫗eʂmF
			 u FREE_SIZE vȉ̒lƂȂƁu IAUTOLOG_ENOMEMORY vԋp܂
			  ȉ̂ƂɒӂĂ
			  1. ftHgł 20 % ȉɂȂƉLG[lԋp܂
			  2. {֐ IAUTOLOG_Management() R[ꍇA
			     ĂяoKv܂
			  
--------------------------------------------------------------------------------------
	߂l	: IAUTOLOG_SUCCESS				: 
			  IAUTOLOG_EBADPARM				: p[^s
			  IAUTOLOG_ENOMEMORY			: [s
			  IAUTOLOG_ECLASS				: IAUTOLOGC^[tF[X
											  gpĂCX^X̍쐬s

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^


=======================================================================================

  	֐	: int	 IAUTOLOG_Management( IAutoLog  *p, const char *szFilename )
		: Ot@C̍쐬Ayэ쐬̊mF
			  ȉ̂ƂɒӂĂ
			  1. Ot@C͍ő5쐬܂
				 (5ȏ쐬ꍇAŌÂ̂̂폜܂)
			  2. t@C szFilename ̑Oɍ쐬A "_log"t^܂
			  3. gq txt ł ({AvɂĐݒ)
			  4. {֐R[ꍇAIAUTOLOG_MemoryCheck() ĂяoKv͂܂
			     ({֐̓ɂČĂяoĂ܂)
--------------------------------------------------------------------------------------
	߂l	: IAUTOLOG_SUCCESS				: 
			  IAUTOLOG_EBADPARM				: p[^s
			  IAUTOLOG_ENOMEMORY			: [s
			  IAUTOLOG_ECLASS				: IAUTOLOGC^[tF[X
											  gpĂCX^X̍쐬s
			  IAUTOLOG_EDIRECTRY			: OǗfBNgɊւ鏈̎s
			  IAUTOLOG_EFILE				: Ot@CɊւ鏈̎s
			  IAUTOLOG_EFAILED				: Ot@C̊Ǘs

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  const char	*szFilename		| t@C


======================================================================================

	֐	: uint32	IAUTOLOG_FileWrite( IAutoLog  *p, boolean Flag, const char *format, ... )
		: Ot@Cւ̏
			  ȉ̂ƂɒӂĂ
			  1. [format] ̃TCY͍ő 512 Byte܂łƂȂĂ܂
			     ȏ̒lꂽꍇ͕̓ۏ؂܂
			  2. {֐̓Ot@Cւ̏ݎɁA
			     [format] ̑OɁu[yyyy/mm/dd hh/mm/ss]\tvA
			     ̌ [\n] t^Ă܂
				 \Ȃꍇ́A[Flag] uFALSEvɐݒ肵Ă
---------------------------------------------------------------------------------------
	߂l	: 񂾃oCg(ݎs 0 Byte)

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  boolean		Flag			| ̕\ TRUE:\ / FALSE:\
			  const char	*format			| 䕶
			  ...							| IvV̈


======================================================================================

  	֐	: int	 IAUTOLOG_Main( IAutoLog *p, IHtmlViewer *pIHTMLViewer, uint32 nCase )
		: Loggerɕ\郍OI
			  ȉ̂ƂɒӂĂ
			  1. ʒmR[h nCase [HVN_SUBMIT]ɒʒm܂
			  2. nCase ɂĎw肵ʒmR[hɂ IAUTOLOG_Debag() R[Ă
-------------------------------------------------------------------------------------
	߂l	: IAUTOLOG_SUCCESS				: 
			  IAUTOLOG_EBADPARM				: p[^s
			  IAUTOLOG_ECLASS				: IAUTOLOGC^[tF[X
			 								  gpĂCX^X̍쐬s
			  IAUTOLOG_EDIRECTRY			: OǗfBNgɊւ鏈̎s
			  IAUTOLOG_EFILE				: Ot@CɊւ鏈̎s

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  IHtmlViewer	*pIHTMLViewer	| IHtmlViewerC^tF[XIuWFNgւ̃|C^
			  uint32		nCase			| ʒmR[h (HVN_SUBMITɒʒm܂)


======================================================================================

  ֐	: int	 IAUTOLOG_Debug( IAutoLog *p, IHtmlViewer *pIHTMLViewer, HViewNotify *pHViewNotify );
		: Loggerւ̏o
			  ȉ̂ƂɒӂĂ
			  1. Logger ւ̏o͂ [\n]  [\t] ̈ʒuɏo͂Ă܂
			     ̂߁AfobO[hɂăO₷邽߂ɂ́A
			     IAUTOLOG_FileWrite() ɂďLg[N悤ɂĉ
			  2. g[NAđĂꍇ́A̃g[NƂĈ܂
			  3. 1 DBGPRINTF() ɂďo͂郍O 36 ByteƐݒ肵Ă܂
				 (36ByteȏゾƂ܂\Ȃ댯邽)
			     36Byte𒴂镶͎IɎ̍sւƕ\܂
			     ݒύXꍇ [SEEK_POINT] ̐ݒlύXĂ
--------------------------------------------------------------------------------------
	߂l	: IAUTOLOG_SUCCESS				: 
			  IAUTOLOG_EBADPARM				: p[^s
			  IAUTOLOG_EFILE				: Ot@CɊւ鏈̎s

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  IHtmlViewer	*pIHTMLViewer	| IHtmlViewerC^tF[XIuWFNgւ̃|C^
			  HViewNotify	*pHViewNotify	| ʒm

========================================================================================

  ֐	: void	 IAUTOLOG_ErrorCheck( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
		: ʓIȃG[R[h𕶎ɕϊ܂
--------------------------------------------------------------------------------------
	߂l	: ߂lȂ

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  int			nCode			| G[R[h
			  char			*pError			| G[R[h𕶎ɕϊۂɊi[obt@
			  uint32		nSize			| pError ɑ΂ nSize ByteRs[

========================================================================================

  ֐	: void	 IAutoLog_BTErrorCheck( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
		: BluetoothñG[R[h𕶎ɕϊ܂
--------------------------------------------------------------------------------------
	߂l	: ߂lȂ

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  int			nCode			| G[R[h
			  char			*pError			| G[R[h𕶎ɕϊۂɊi[obt@
			  uint32		nSize			| pError ɑ΂ nSize ByteRs[

========================================================================================

  ֐	: void	 IAutoLog_KDDIErrorCheck( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
		: KDDIC^tF[X̃G[R[h𕶎ɕϊ܂
--------------------------------------------------------------------------------------
	߂l	: ߂lȂ

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  int			nCode			| G[R[h
			  char			*pError			| G[R[h𕶎ɕϊۂɊi[obt@
			  uint32		nSize			| pError ɑ΂ nSize ByteRs[

========================================================================================

  ֐	: void	 IAutoLog_FILEErrorCheck( IAutoLog  *p, IFileMgr * pIFileMgr, char *pError, uint32 nSize );
		: IFILE,IFILEMGRC^tF[X̃G[R[h𕶎ɕϊ܂
--------------------------------------------------------------------------------------
	߂l	: ߂lȂ

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  IFileMgr		*pIFileMgr		| IFileMgrC^tF[XIuWFNgւ̃|C^
			  char			*pError			| G[R[h𕶎ɕϊۂɊi[obt@
			  uint32		nSize			| pError ɑ΂ nSize ByteRs[


========================================================================================

  ֐	: void	 IAutoLog_AUTOErrorCheck( IAutoLog  *p, int nCode, char *pError, uint32 nSize );
		: IAUTOLOGC^tF[X̃G[R[h𕶎ɕϊ܂
--------------------------------------------------------------------------------------
	߂l	: ߂lȂ

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  int			nCode			| G[R[h
			  char			*pError			| G[R[h𕶎ɕϊۂɊi[obt@
			  uint32		nSize			| pError ɑ΂ nSize ByteRs[

========================================================================================

  ֐	: void	 IAutoLog_GetParam( IAutoLog  *p, const char  *pszData, const char *element, char *pszBuffer, uint16  nBufSize );
		: L[gpĕ̃p[^擾
			  ȉ̂ƂɒӂĂ
			  ̊mۂ͊O֐łȂĂ̂ƂĂׁA
			  G[`FbNsĂ܂
			  ̑G[֘AɂāAt[ȏԂȂ̂ŊOł̃`FbNdvł

--------------------------------------------------------------------------------------
	߂l	: ߂lȂ

		: IAutoLog		*p				| IAutoLogrC^tF[XIuWFNgւ̃|C^
			  const char	*pszData		| Ώۂ̕
			  const char	*element		| 镶
			  char			*pszBuffere		| 擾󂯎obt@
			  uint16		nBufSize		| pszBuffer̍ől

======================================================================================*/


// -----------------------------------------------------------
//		struct
// -----------------------------------------------------------

typedef struct _AUTOLOG
{

	DECLARE_VTBL( IAutoLog )							//	C^[tF[X

	AEEApplet        aApplet;							//	AEEApplet
	uint32			 m_nReferenceCount ;				//	QƃJE^

	IFileMgr		*m_pFileMgr ;						//	IFileMgr̃CX^X
	IFile			*m_pFile ;							//	IFilẽCX^X
	IHtmlViewer     *pIHtmlViewer;						//	IHtmlViewer̃CX^X

	char			 szCreateName[MIDDLE_BUFFER] ;		//	Ot@C̖O(pXȂ)
	char			 szFileName[MIDDLE_BUFFER] ;		//	Ot@C̖O(pXt)
	char			*pszReadBuf;						//	Ot@C̃f[^
	char			*pszReadPoint;						//	Ot@C̐擪|C^
	int32			 unReadSize;						//	Ot@C̃TCY

}	AutoLog;


// -----------------------------------------------------------
//		Function 
// -----------------------------------------------------------
// --------------------------------------------------------
// 쐬	: 2004N312
// ֐	: IAutoLog_FileCheck
// 		: Ot@C̊Ǘ
//			  Ot@C5ȏɂȂꍇA
//			  ŌẪt@C폜
// ߂l	: boolean				| Ǘ  / s tO
// 		: AutoLog  *pAutoLog	| ėp\
// --------------------------------------------------------
boolean	IAutoLog_FileCheck( AutoLog  *pAutoLog );


// --------------------------------------------------------
// 쐬	: 2004N317
// ֐	: IAutoLog_DBGTimer
// 		: LoggerɂAo͂܂Ȃ߁A
//			  ISHELL_SetTimer()pAo͂sĂ܂B
//			  ^C}[ 6 ~bŐݒ肵Ă܂B
// ߂l	: void					| ݒ薳
// 		: AutoLog  *pAutoLog	| ėp\
// --------------------------------------------------------
void	IAutoLog_DBGTimer( AutoLog  *pAutoLog );


#endif //_IAUTOLOG_H_






