#ifndef AEEMPUTILOM_H
#define AEEMPUTILOM_H

/*============================================================================
FILE: AEEMPUtilOM.h

SERVICES:  Media Playing Services

DESCRIPTION:
   This file defines an abstract interface for BREW Interactive Multimedia Player.

PUBLIC CLASSES:  Not Applicable

INITIALIZATION AND SEQUENCING REQUIREMENTS:  Not Applicable

============================================================================*/
/*===============================================================================
    INCLUDES AND VARIABLE DEFINITIONS
===============================================================================*/

/*-------------------------------------------------------------------
      Include Files
-------------------------------------------------------------------*/

#include "AEE.h"
#include "AEEMPUtil.h"

/*-------------------------------------------------------------------
      Type Declarations
-------------------------------------------------------------------*/
// Define interface pointers
typedef struct _IMPUtilOM  IMPUtilOM;


enum{
    AEE_MPUTILOM_OUTSIDEMEMORY_LOAD = (AEE_MPUTIL_OUTSIDEMEMORY_UMOUNT + 1)
};


//********************************************************************************************************************************
//
// IMPUtilOM Interface
//
//********************************************************************************************************************************

QINTERFACE(IMPUtilOM)
{
    INHERIT_IMPUtil(IMPUtilOM);
    int		(*LoadOutsideMemory)			( IMPUtilOM * po );
    boolean	(*IsMounted)				( IMPUtilOM * po );
};

#define IMPUTILOM_LoadOutsideMemory(p)			GET_PVTBL(p, IMPUtilOM)->LoadOutsideMemory(p)
#define IMPUTILOM_IsMounted(p)				GET_PVTBL(p, IMPUtilOM)->IsMounted(p)

#endif // AEEMPUTILOM_H
