/*==================================================================================
FILE:  BrewGPS.h                                                                    
                                                                                    
SERVICES:                                                                           
   BrewGPSp                                                                        
                                                                                    
                                                                                    
====================================================================================*/
/*==================================================================================
                                                                                    
                        EDIT HISTORY FOR MODULE                                     
                                                                                    
when       who           what, where, why                                           
--------   ---           -----------------------------------------------------------
06/14/04   otsuka@ISB    [PTX802-TRK6047] ʃLZ̓sΉ
05/26/04   otsuka@ISB    [PTX802-TRK4102] ʃLZt[YΉ
05/17/04   otsuka@ISB    [PTX802-TRK2502] ʃLZ̑ʃLZΉ
04/26/04   otsuka@ISB    [PTX802-TRK734-GPS_BREW] GPSBREWAgPPP GPSʃLZWaitΉ
03/10/04   otsuka@ISB    [PTX802-BREW  I/F _1] ʒuf[^ُs
03/02/04   otsuka@ISB    [PTX802-ORIFNO] ʏ擾vύXΉ
02/04/04   otsuka@ISB    [PTX802]                                                   
                          GPSOne ServiceΉƂĐVK쐬                          
====================================================================================*/
#if !defined(__BREWGPS_H__)
#define __BREWGPS_H__

//**********************************************************************
//	Includes
//**********************************************************************
#include "AppEvent.h"
#include "ApiGPSOne.h"
#include "BrewRpc.h"
typedef void (*PFNGETGPSINFOCB)(void *pUser, EN_GPSONE_CLIENT_RET nErr, ST_GPSONE_CLIENT_INFO *pInfo);
typedef void (*PFNGETDIRECTIONCB)(void *pUser, EN_GPSONE_CLIENT_RET nErr, ST_GPSONE_REPORT_OR_DIRECTION *info);
typedef void (*PFNGPSCANCELCB)(void *pUser);

//*********************************************************************/
//	Defines
//*********************************************************************/
//enum {
//	BREW_RPC_GPSINFO = BREW_RPCGRP(BREW_RPCGRP_GPS),	// BA:GPSʗv
//	BREW_RPC_GPSCAN		,								// BA:GPSʃLZ
//	BREW_RPC_ORSTART,									// BA:ʊpT[rXJnv
//	BREW_RPC_ORSTOP,									// BA:ʊpT[rXIv
//	BREW_RPC_ORINFO,									// BA:ʊp擾v
//	BREW_RPC_REQ_GPSINFO,								// AB:GPSʏ擾
//	BREW_RPC_REQ_ORINFO,								// AB:ʊp擾
//	BREW_RPC_REQ_GPSCAN,								// AB:GPSʃLZ
//// [PTX802-TRK4102] ʏԎ擾 [S]
//	BREW_RPC_GETSTATUS,									// BAFʏԎ擾
//// [PTX802-TRK4102] ʏԎ擾 [E]
//};

//*********************************************************************/
//	\
//*********************************************************************/
// BREWv
typedef struct {
	unsigned long		RpcCmd;					// qobR}h
	unsigned long		Prm1;					// p[^P
	unsigned long		Prm2;					// p[^Q
	unsigned long		Prm3;					// p[^R
} ST_BREW_RPC_GPS;

typedef struct {
	unsigned long		RpcCmd;					// qobR}h
// [PTX802-BREW  I/F _1] ʒuf[^ُs [S]
//	void				* info;					// ʌ
	ST_GPSONE_CLIENT_INFO info;					// ʌ
// [PTX802-BREW  I/F _1] ʒuf[^ُs [E]
	int					ret;					// s[EN_GPSONE_CLIENT_RET]
	int					err_code;				// G[R[h[EN_GPSOEN_CMD_ERR_TYPE]
} ST_BREW_RPC_REQ_GPS;
// Callback
typedef struct {
	PFNGETGPSINFOCB pGpsCB;
	void *pUser;
} ST_BREWGPS_CB;
typedef struct {
	void (*pOrCB)(void *pUser, EN_GPSONE_CLIENT_RET nErr, ST_GPSONE_REPORT_OR_DIRECTION *info);
	void *pUser;
} ST_BREWOR_CB;
typedef struct {
	PFNGPSCANCELCB pGpsCanCB;
	void *pUser;
// [PTX802-TRK4102] ʃLZt[YΉ [S]
// [PTX802-TRK734-GPS_BREW] LZtOǉ.[S]
//	boolean bCanceling;
// [PTX802-TRK734-GPS_BREW] LZtOǉ.[E]
// [PTX802-TRK4102] ʃLZt[YΉ [E]
// [PTX802-TRK2502] LZwaittOǉ.[S]
// [PTX802-TRK6047] OɃLZʒm̏ꍇŃVOiݒ肷邽߃tO폜 [S]
//	boolean bWaiting;
// [PTX802-TRK6047] OɃLZʒm̏ꍇŃVOiݒ肷邽߃tO폜 [E]
// [PTX802-TRK2502] LZwaittOǉ.[E]
} ST_BREWGPSCAN_CB;

//**********************************************************************
//	Functions
//**********************************************************************
int BrewGPSOneGetGPSInfo(EN_GPSONE_CLIENT_ID client_id, void *prm, ST_GPSONE_BREW_OPE_PARAM *operation, PFNGETGPSINFOCB pcb, void *pUser);
int BrewGPSOneGetGPSCan(EN_GPSONE_CLIENT_ID client_id, EN_GPSONE_CANCEL_TYPE cancel_type, PFNGPSCANCELCB pcb, void * pUser);
// [PTX802-TRK734-GPS_BREW] WaitpGPSʃLZ֐ǉ.[S]
int BrewGPSOneGetGPSCanSync(EN_GPSONE_CLIENT_ID client_id, PFNGPSCANCELCB pcb, void * pUser);
// [PTX802-TRK734-GPS_BREW] WaitpGPSʃLZ֐ǉ.[E]
// [PTX802-ORIFNO] ʏ擾vύXΉ. Cxg폜 [S]
// int BrewGPSOneGetDirection(EN_GPSONE_CLIENT_ID client_id, PFNGETDIRECTIONCB pcb, void *pUser);
int BrewGPSOneGetDirection(EN_GPSONE_CLIENT_ID client_id, ST_GPSONE_REPORT_OR_DIRECTION *reportDir);
// [PTX802-ORIFNO] ʏ擾vύXΉ. Cxg폜 [E]
int BrewGPSOneOrServiceStart(EN_GPSONE_CLIENT_ID client_id);
int BrewGPSOneOrServiceEnd(EN_GPSONE_CLIENT_ID client_id);
unsigned long BrewObsRpcGrpGPS(void *pRpcBlk);
unsigned long BrewTaskRpcGrpGPS(void *pRpcBlk);
unsigned long BrewAppGPSOneGetGPSInfo(ST_BREW_RPC_GPS *pRpcBlk);
unsigned long BrewAppGPSOneGetGPSCan(ST_BREW_RPC_GPS *pRpcBlk);
unsigned long BrewAppGPSOneGetDirection(ST_BREW_RPC_GPS *pRpcBlk);
unsigned long BrewAppGPSOneOrServiceStart(ST_BREW_RPC_GPS *pRpcBlk);
unsigned long BrewAppGPSOneOrServiceStop(ST_BREW_RPC_GPS *pRpcBlk);
unsigned long BrewTaskRpcGetGPSInfoCB(ST_BREW_RPC_REQ_GPS *pRpcBlk);
// [PTX802-ORIFNO] ʏ擾vύXΉ. Cxg폜 [S]
// unsigned long BrewTaskRpcGetDirectionCB(ST_BREW_RPC_REQ_GPS *pRpcBlk);
// [PTX802-ORIFNO] ʏ擾vύXΉ. Cxg폜 [E]
unsigned long BrewTaskRpcGPSCancelCB(ST_BREW_RPC_REQ_GPS *pRpcBlk);
int BrewGPSGetInfoCB(ST_EVENT_GPSONE_CLIENT *pEvent);
// [PTX802-ORIFNO] ʏ擾vύXΉ. Cxg폜 [S]
// int BrewGPSGetDirectionCB(ST_EVENT_VECTORONE *pEvent);
// [PTX802-ORIFNO] ʏ擾vύXΉ. Cxg폜 [E]
int BrewGPSCancelCB(void *pEvent);
// [PTX802-TRK2502] R[obNǉ [S]
void BrewGPSInitCBInfo(void);
// [PTX802-TRK2502] R[obNǉ [E]
// [PTX802-TRK4102] ʏԎ擾 [S]
unsigned long BrewGPSOneGetStatus();
unsigned long BrewAppGPSOneGetStatus(ST_BREW_RPC_GPS *pRpcBlk);
// [PTX802-TRK4102] ʏԎ擾 [E]

/***** End Of List ***************************************************/
#endif /* !defined(__BREWGPS_H__) */
