#ifndef IDATAFOLDER_H
#define IDATAFOLDER_H
/*===========================================================================================

FILE            : IDataFolder.h

SERVICES        : Data Folder Access Interface

DESCRIPTION     :

PUBLIC CLASSES  :

INITIALIZATION AND SEQUENCING REQUIREMENTS :

      Copyright  1999-2004 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

===========================================================================================*/

/*===========================================================================================

                        EDIT HISTORY FOR MODULE

When        Who    Keyword             what, where, why
----------  -----  ------------------  ------------------------------------------------------
10/18/04                               Create file
12/08/04                               Added IDATAFOLDER_Delete()
03/02/05                               1.0.7őΉ
                                     E\́wKDDIDFFileInfoExxo̕ύX
                                      unbExternalMemoryvunExternalMemoryv
                                     E\pt@CɊgq̃P[Xł́At@C
                                       ɂgqt^Ή
                                     EfoCXwDF_DEV_KDFCPCx폜ΉB
04/15/05                               1.1.0-02őΉ
                                     EfoCXwDF_DEV_KDFCTARxǉΉB
                                     EfoCXwDF_DEV_KDFCPCxΉi`̂݁jB
06/20/05                               1.1.1őΉ
                                     EfoCXwDF_DEV_KDFCTARCIPHERxǉΉB
                                     EfoCXwDF_DEV_KDFCKDRxǉΉi`̂݁jB
                                     EfoCXwDF_DEV_KDFJPEGxǉΉi`̂݁jB
                                     EfoCXwDF_DEV_KDFCJPEGxǉΉi`̂݁jB
11/30/05                               1.2.0őΉ
                                     EfoCXwDF_DEV_KDFCKDRTARxǉΉBi`̂݁jB [SPEC120-08]
                                     EfoCXwDF_DEV_APPCUSTOM08xǉΉBi`̂݁jB[SPEC120-08]
                                     EfoCXwDF_DEV_APPCUSTOM09xǉΉBi`̂݁jB[SPEC120-08]
                                     EfoCXwDF_DEV_APPCUSTOM10xǉΉBi`̂݁jB[SPEC120-08]
                                     EfoCXwDF_DEV_APPCUSTOM11xǉΉBi`̂݁jB[SPEC120-08]
12/07/05                               1.2.0-02őΉ
                                     EfoCXύX
                                       wDF_DEV_KDFCCAMx      => wDF_DEV_KDFCAMx
                                       wDF_DEV_KDFCCIPHERx   => wDF_DEV_KDFCIPHERx
                                       wDF_DEV_KDFCTARCIPHERx=> wDF_DEV_KDFCIPHERTARx

===========================================================================================*/

/*===========================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Defines
-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------
   Include Files
-------------------------------------------------------------------------------------------*/
#include "AEE.h"
#include "AEEInterface.h"
#include "AEEFile.h"


/*-------------------------------------------------------------------------------------------
   Constant Declarations
-------------------------------------------------------------------------------------------*/

/*===========================================================================================
 Macros
===========================================================================================*/

/*-------------------------------------------------------------------------------------------
   Type Declarations
-------------------------------------------------------------------------------------------*/
/* KDDIDFDEVICE                              */
   /* obsoleted macro: available until end of 2006 */
#define   DF_DEV_KDFCCAM        3
#define   DF_DEV_KDFCCIPHER     6
#define   DF_DEV_KDFCTARCIPHER  8

   /* ver1.0.0 */
#define   DF_DEV_KDF            0      /* ړ@̃f[^tH_                  */
#define   DF_DEV_KDFTAR         1      /* {tarA[JCu                       */
#define   DF_DEV_KDFC           2      /* Of[^tH_                  */
#define   DF_DEV_KDFCAM         3      /* OfWJtH_                */
#define   DF_DEV_KDFCMAIL       4      /* O[̈(gp)              */
#define   DF_DEV_KDFCPC         5      /* OPC̈(gp)                  */
#define   DF_DEV_KDFCIPHER      6      /* OÍ̈(CPRMΉړ@̂)  */
#define   DF_DEV_KDFCTAR        7      /* OÍ̈TARA[JCu     */
   /* ver1.1.1 */
#define   DF_DEV_KDFCIPHERTAR   8      /* OÍ̈tarA[JCu */

   /* custom application area */
#define   DF_DEV_APPCUSTOM     64
   /* for IMP */
#define   DF_DEV_KDFCKDR        (DF_DEV_APPCUSTOM)    /* KDDIÍ̈                            */
#define   DF_DEV_KDFJPEG        (DF_DEV_APPCUSTOM+1)  /* ړ@̒쌠JPEGI(IMPp)       */
#define   DF_DEV_KDFCJPEG       (DF_DEV_APPCUSTOM+2)  /* O̒쌠JPEG(IMPp)         */

   /* for E-Books */
#define   DF_DEV_KDFCKDRTAR     (DF_DEV_APPCUSTOM+3)  /* KDDIÍ̈TARA[JCu           */

   /* for IPVT */
#define   DF_DEV_APPCUSTOM08    (DF_DEV_APPCUSTOM+8)
#define   DF_DEV_APPCUSTOM09    (DF_DEV_APPCUSTOM+9)
#define   DF_DEV_APPCUSTOM10    (DF_DEV_APPCUSTOM+10)
#define   DF_DEV_APPCUSTOM11    (DF_DEV_APPCUSTOM+11)

#define   DF_DEV_OEMCUSTOM    128      /* OEMJX^̈ */

#ifdef WIN32
typedef unsigned KDDIDFDEVICE;
#else
typedef byte KDDIDFDEVICE;
#endif


enum {                                 /* GPSfm               */
   GPS_FIX_MODE = 0,                   /* GPS-Fix[h       */
   HYBRID_FIX_MODE,                    /* Hybrid-Fix[h    */
   AFLT_FIX_MODE,                      /* AFLT-Fix[h      */
   BS_REGION_MODE,                     /* BS Region[h     */
   CELL_SECTOR_CENTER_MODE,            /* Cell Sector Center[h */
   PRE_FIX_MODE                        /* Pre-Fix[h       */
};

#ifdef WIN32
typedef unsigned GPSfm;
#else
typedef byte GPSfm;
#endif


enum {                                 /* GPSdatum             */
   WGS84_SOKUTIKEI = 0,                /* WGS-84 nn        */
   TOKYO_JAPAN_SOKUTIKEI               /* Tokyoi{jnn  */
};

#ifdef WIN32
typedef unsigned GPSdatum;
#else
typedef byte GPSdatum;
#endif


enum {                                 /* GPSunit                     */
   DMS_FORMAT = 0,                     /* dms(xEEb)tH[}bg */
   DEGREE_FORMAT                       /* degree(x)tH[}bg      */
};

#ifdef WIN32
typedef unsigned GPSunit;
#else
typedef byte GPSunit;
#endif

typedef struct _GPSParam {
   char     szUrl[255+1];              /* GPSURL                           */
   GPSfm    fm;                        /* mFx (ʃ[h)              */
   GPSdatum datum;                     /* nn                               */
   GPSunit  unit;                      /* vtH[}bg                     */
   int32    dwLat;                     /* Zoꂽʒüܓx         */
   int32    dwLon;                     /* Zoꂽʒǔox         */
} GPSParam;

typedef struct _KDDIDFFileInfo {
   uint32      dwSize;                 /* sizeof(KDDIDFFileInfo) or sizeof(KDDIDFFileInfoEx) */
   const char  szTitle[63+1];          /* \p^Cg(SJIS ASCIIZ)        */
   const char  szName[255+1];          /* t@C(SJIS ASCIIZ)            */
   uint32      dwCreationDate;         /* f[^tH_i[̎(1980/1/6 0iUTCj̕b) */
   uint32      dwFileSize;             /* t@CTCY(byte)                 */
} KDDIDFFileInfo;

typedef struct _KDDIDFFileInfoEx {
   /* ver1.0.0 */
   KDDIDFFileInfo dfFileInfo;          /* {t@C                     */
   uint32         dwPlayTime;          /* f[^Đ(msec)                 */
   boolean        bRelatedState;       /* f[^pĂ邩ǂ̃Xe[^X */
   int            nGPSInfo;            /* GPSҏW                      */
   GPSParam       param;               /* GPS\                        */
   boolean        bHasCopyWrite;       /* 쌠̗L                         */
   char           szAuthorAtom[80+2];  /* Җ(̔) (SJIS ASCIIZ)     */
   char           szRightAtom[80+2];   /* Җ(SJIS ASCIIZ)                */
   boolean        bEmailAttach;        /* E[Yt                      */
   boolean        bSerialOut;          /* VAɂOM           */
   int            nExternalMemory;     /* Oۑ                   */
   int            nSoundEditable;      /* AtRҏW                     */
   int            nTelopEditable;      /* ebvҏW                     */
   int            nUseOtherHS;         /* @ύXł̗p(Op)     */
   /* ver1.1.1 */
   boolean        bUrlAuth;            /* URLF؍ς݂TRUEA֌WAF؂FALSE */
   char           szAuthURL[64+2];     /* URLF؍ς݂̃t@Cł͔F؂URL */
} KDDIDFFileInfoEx;

typedef void (* PFNDFFILECB)(void * pUser, KDDIDFFileInfo * pDFFI, int nError);
typedef void (* PFNDFCB)    (void * pUser, int nError);

typedef struct IDataFolder IDataFolder;

/*-------------------------------------------------------------------------------------------
   Macros Declarations
-------------------------------------------------------------------------------------------*/

/*===========================================================================================
 FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IDataFolder)
{
   INHERIT_IBase(IDataFolder);
   uint32  (* GetFreeSpace) (IDataFolder * pDF, KDDIDFDEVICE dev, uint32 * pdwFree, uint32 * pdwTotal, uint32 * pdwFileSize, uint32 * pdwFileNum);
   int32   (* RegisterEvent)(IDataFolder * pDF, int16 nCardNo, AEECLSID clsid, AEEEvent evt);
   uint32  (* Open)         (IDataFolder * pDF, KDDIDFDEVICE dev, const char * pszFileName, uint32 dwTotalWriteSize, AEEOpenFileMode mode, const char * szOption);
   uint32  (* Seek)         (IDataFolder * pDF, FileSeekType seekType, int32 moveDistance);
   int     (* Read)         (IDataFolder * pDF, int32 * pdwBufferSize, void * pBuffer);
   int     (* Write)        (IDataFolder * pDF, int32 * pdwWriteSize, void * pBuffer);
   void    (* Close)        (IDataFolder * pDF, KDDIDFFileInfo * pFileInfo, boolean bCommit);
   uint32  (* SelectUI)     (IDataFolder * pDF, KDDIDFDEVICE dev, uint16 wSelectNum, uint32 dwMaxFileSize, boolean bDir, PFNDFFILECB pfn, KDDIDFFileInfo * pFInfo, void * pUser);
   uint32  (* DeleteUI)     (IDataFolder * pDF, KDDIDFDEVICE dev, uint32 dwDeleteSize, PFNDFCB pfn, void * pUser);
   uint32  (* Delete)       (IDataFolder * pDF, const char* pszFilePath);
   uint32  (* EnumInit)     (IDataFolder * pDF, KDDIDFDEVICE dev, const char * pszSubDir);
   uint32  (* EnumNext)     (IDataFolder * pDF, KDDIDFFileInfo * pFInfo);
   uint32  (* GetFileInfoEx)(IDataFolder * pDF, const char * pszFilePath, KDDIDFFileInfoEx * pFileInfoEx);
   boolean (* HandleEvent)  (IDataFolder * pDF, AEEEvent evt, uint16 wp, uint32 dwp);
};

/*-------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IDATAFOLDER_AddRef(p)                                        AEEGETPVTBL((p),IDataFolder)->AddRef((p))
#define IDATAFOLDER_Release(p)                                       AEEGETPVTBL((p),IDataFolder)->Release((p))
#define IDATAFOLDER_GetFreeSpace(p, dev, pF, pT, pFS, pdwF)          AEEGETPVTBL((p),IDataFolder)->GetFreeSpace(p, dev, pF, pT, pFS, pdwF)
#define IDATAFOLDER_RegisterEvent(p, n, cls, evt)                    AEEGETPVTBL((p),IDataFolder)->RegisterEvent(p, n, cls, evt)
#define IDATAFOLDER_Open(p, dev, pF, dw, m, szO)                     AEEGETPVTBL((p),IDataFolder)->Open(p, dev, pF, dw, m,szO)
#define IDATAFOLDER_Seek(p, s, n)                                    AEEGETPVTBL((p),IDataFolder)->Seek(p, s, n)
#define IDATAFOLDER_Read(p, pdwB, pB)                                AEEGETPVTBL((p),IDataFolder)->Read(p, pdwB, pB)
#define IDATAFOLDER_Write(p, pS, pB)                                 AEEGETPVTBL((p),IDataFolder)->Write(p, pS, pB)
#define IDATAFOLDER_Close(p, pFI, bC)                                AEEGETPVTBL((p),IDataFolder)->Close(p, pFI, bC)
#define IDATAFOLDER_SelectUI(p, dev, wSN, dwFS, bD, pfn, pFI, pU)    AEEGETPVTBL((p),IDataFolder)->SelectUI(p, dev, wSN, dwFS, bD, pfn, pFI, pU)
#define IDATAFOLDER_DeleteUI(p, dev, dwDS, pfn, pU)                  AEEGETPVTBL((p),IDataFolder)->DeleteUI(p, dev, dwDS, pfn, pU)
#define IDATAFOLDER_Delete(p, pF)                                    AEEGETPVTBL((p),IDataFolder)->Delete(p, pF)
#define IDATAFOLDER_EnumInit(p, dev, pSD)                            AEEGETPVTBL((p),IDataFolder)->EnumInit(p, dev, pSD)
#define IDATAFOLDER_EnumNext(p, pFI)                                 AEEGETPVTBL((p),IDataFolder)->EnumNext(p, pFI)
#define IDATAFOLDER_GetFileInfoEx(p, pFP, pFIEx)                     AEEGETPVTBL((p),IDataFolder)->GetFileInfoEx(p, pFP, pFIEx)
#define IDATAFOLDER_HandleEvent(p, evt, wp, dwp)                     AEEGETPVTBL((p),IDataFolder)->HandleEvent(p, evt, wp, dwp)


/*===========================================================================================
   DATA STRUCTURE DOCUMENTATION
=============================================================================================
=============================================================================================
PFNDFFILECB

Description:
   PFNDFFILECB́AIDATAFOLDER_SelectUI()nR[obN֐̌^B

Definition:

   typedef void(* PFNDFFILECB)(void * pUser, KDDIDFFileInfo * pDFFI, int nError)

Members:
   pUser  : [U[f[^
   pDFFI  : t@C
   nError : G[R[h

Comments:
   nErrorɂĕԋpG[l͉L̒ʂB
   SUSCEESS  : I
   EFAILED   : SelectUIɂăt@CIȂB
   ENOMEMORY : ֐s邾̃ȂB

Version:
   KDDI BREW3.1 ڈړ@

See Also:
   KDDIDFFileInfo
   IDATAFOLDER_SelectUI

=============================================================================================
PFNDFCB

Description:
   PFNDFCB́AIDATAFOLDER_DeleteUI()ɓnR[obN֐̌^B

Definition:

   typedef void(* PFNDFCB)(void * pUser, int nError)

Members:
   pUser  : [U[f[^
   nError : G[R[h

Comments:
   nErrorɂĕԋpG[l͉L̒ʂB
   SUCCESS   : ɏsꂽB
   EFAILED   : DeleteUIɂĕKvȐ̓TCỸt@C폜łȂ
               Ⴕ̓LZꂽB
   ENOMEMORY : ֐s邾̃ȂB


Version:
   KDDI BREW3.1 ڈړ@

See Also:
   IDATAFOLDER_DeleteUI

=============================================================================================
KDDIDFFileInfoEx

Description:
   ̃f[^\̓f[^tH_t@Cڍ׏擾B
   ڍ׏ɊւẮAuf[^tH_dlvucdma2000 1x^1xWINeznavigation @\^\
   dlv킹ĎQƂ̂ƁB
   擾ł́Aړ@̗puf[^tH_dlṽo[WɈˑB

Definition:

   typedef struct _KDDIDFFileInfoEx {
      // ver1.0.0
      KDDIDFFileInfo dfFileInfo;          // {t@C
      uint32         dwPlayTime;          // f[^Đ(msec)
      boolean        bRelatedState;       // f[^pĂ邩ǂ̃Xe[^X
      int            nGPSInfo;            // GPSҏW
      GPSParam       param;               // GPS\
      boolean        bHasCopyWrite;       // 쌠̗L
      char           szAuthorAtom[80+2];  // Җ(̔) (SJIS ASCIIZ)
      char           szRightAtom[80+2];   // Җ(SJIS ASCIIZ)
      boolean        bEmailAttach;        // E[Yt
      boolean        bSerialOut;          // VAɂOM
      int            nExternalMemory;     // Oۑ
      int            nSoundEditable;      // AtRҏW
      int            nTelopEditable;      // ebvҏW
      int            nUseOtherHS;         // @ύXł̗p(Op)
      // ver1.1.1
      boolean        bUrlAuth;            // URLF؍ς݂TRUEA֌WAF؂FALSE
      char           szAuthURL[64+2]      // URLF؍ς݂̃t@Cł͔F؂URL
   } KDDIDFFileInfoEx;

   GPSp[^̍\

   typedef struct _GPSParam
   {
      char     szUrl[255+1];  // GPSURL
      GPSfm    fm;            // mFx (ʃ[h)
      GPSdatum datum;         // nn
      GPSunit  unit;          // vtH[}bg
      int32    dwLat;         // Zoꂽʒüܓx
      int32    dwLon;         // Zoꂽʒǔox
   } GPSParam;

   GPSp[^̒`

   enum
   {
      WGS84_SOKUTIKEI = 0,    // WGS-84 nn
      TOKYO_JAPAN_SOKUTIKEI   // Tokyoi{jnn
   };
   #ifdef WIN32
   typedef unsigned GPSdatum;
   #else
   typedef byte GPSdatum;
   #endif


   enum
   {
      DMS_FORMAT= 0,       // dms(xEEb)tH[}bg
      DEGREE_FORMAT        // degree(x)tH[}bg
   };
   #ifdef WIN32
   typedef unsigned GPSunit;
   #else
   typedef byte GPSunit;
   #endif


   enum
   {
      GPS_FIX _MODE= 0,          // GPS-Fix[h
      HYBRID_FIX_MODE,           // Hybrid-Fix[h
      AFLT_FIX_MODE,             // AFLT-Fix[h
      BS_REGION_MODE,            // BS Region[h
      CELL_ SECTOR_CENTER_MODE,  // Cell Sector Center[h
      PRE_FIX_MODE               // Pre-Fix[h
   };
   #ifdef WIN32
   typedef unsigned GPSfm;
   #else
   typedef byte GPSfm;
   #endif


Members:
   o       O
   dfFileInfo      : {t@C
                     Ăяo͕KdfFileInfo. dfFileInfo .deSize = sizeof(KDDIDFFileInfoEx)ݒ肷邱   
   bEmailAttach    : E[ւ̓Yt                                                                       
                     TRUE F  Email֓Yt
                     FALSE F Email֓Yts
   bSerialOut      : VAɂOւ̑M                                                            
                     TRUE F VAɂOւ̑M
                     FALSE F VAɂOւ̑Ms
   nUseOtherHS     : @ύXł̗p(Ô)                                                    
                     0 F Ȃ
                     1 F p
                     2 F ps
   dwPlayTime      : f[^̍Đ(ms)
                     ĐԂȂꍇ0
   bRelatedState   : TRUE F f[^ړ@ŗpĂ
                     FALSE F f[^ړ@ŗpĂȂ
   nGPSInfo        : 0 F GPSȂ
                     1 F GPSҏW
                     2 F GPSҏWs
   GPSParam        : GPSp[^̍\́Bueznavigation @\^\dlvQ
   bHasCopyWrite   : TRUE  F 쌠
                     FALSE F 쌠Ȃ
   szAuthorAtom    : AuthorAtom Ɋi[Ă镶B
                     f80Byte̕f{h\0h݂Ȃꍇ́h\0h
   szRightAtom     : RightAtom Ɋi[Ă镶B
                     f80Byte̕f{h\0h݂Ȃꍇ́h\0h
   nExternalMemory : Oւ̕ۑ
                     0 F 񖳂ȂA͊Oɂꍇ
                     1 F Oւ̕ۑ
                     2 F Oւ̕ۑs
   nSoundEditable  : AtRҏW
                     0 F Ȃ
                     1 F AtRҏW
                     2 F AtRҏWs
   nTelopEditable  : ebvҏW
                     0 F Ȃ
                     1 F ebvҏW
                     2 F ebvҏWs
   nUseOtherHS     : 0 F Ȃ
                     1 F @ό̗p
                     2 F @ό̗ps
   bUrlAuth        : TRUE  F t@CURLF؍ςݏ
                     FALSE F sAȊȌԂ̏ꍇ
   szAuthURL       : t@CURLF؍ς݂łꍇ́AF؂sURL


Comments:
   Ȃ

See Also:
   IDATAFOLDER_GetFileInfoEx

=============================================================================================
KDDIDFDEVICE

Description:
   ENUḾABREWtH_ƃt@Ĉs̃foCXw肷B

Definition:

#define   DF_DEV_KDF            0      // ړ@̃f[^tH_
#define   DF_DEV_KDFTAR         1      // {tarA[JCu
#define   DF_DEV_KDFC           2      // Of[^tH_
#define   DF_DEV_KDFCAM         3      // OfWJtH_
#define   DF_DEV_KDFCMAIL       4      // O[̈(gp)
#define   DF_DEV_KDFCPC         5      // OPC̈(gp)
#define   DF_DEV_KDFCIPHER      6      // OÍ̈(CPRMΉړ@̂)
#define   DF_DEV_KDFCTAR        7      // OÍ̈TARA[JCu
#define   DF_DEV_KDFCIPHERTAR   8      // OÍ̈tarA[JCu

#define   DF_DEV_APPCUSTOM     64      // ʃAvP[V̈
#define   DF_DEV_KDFCKDR       (DF_DEV_APPCUSTOM)    // OKDRÍ̈(KDRΉ[̂)
#define   DF_DEV_KDFJPEG       (DF_DEV_APPCUSTOM+1)  // ړ@JPEGIpfoCX
#define   DF_DEV_KDFCJPEG      (DF_DEV_APPCUSTOM+2)  // OJPEGIpfoCX
#define   DF_DEV_OEMCUSTOM    128      // OEMJX^̈

// obsoleted macro: available until end of 2006
#define   DF_DEV_KDFCCAM        3      // OfWJtH_
#define   DF_DEV_KDFCCIPHER     6      // Iɍ폜
#define   DF_DEV_KDFCTARCIPHER  8      // Iɍ폜

Comments:
   Ȃ

See Also:
   Ȃ

=============================================================================================
=============================================================================================
   INTERFACE DOCUMENTATION
=============================================================================================
*/
#endif // __IDATAFOLDER_H__

