#ifndef IKDDIADDRBOOK_H
#define IKDDIADDRBOOK_H
/*@==========================================================================================

FILE            : IKDDIAddrBook.h

SERVICES        : IKDDIAddrBook Access Interface

DESCRIPTION     :

PUBLIC CLASSES  :

INITIALIZATION AND SEQUENCING REQUIREMENTS :

      Copyright  1999-2005 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

===========================================================================================*/

/*@==========================================================================================

                        EDIT HISTORY FOR MODULE

When        Who    Keyword             what, where, why
----------  -----  ------------------  ------------------------------------------------------
11/16/05                               Create file
===========================================================================================*/

/*@==========================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
===========================================================================================*/
/*@------------------------------------------------------------------------------------------
   Defines
-------------------------------------------------------------------------------------------*/

/*@------------------------------------------------------------------------------------------
   Include Files
-------------------------------------------------------------------------------------------*/
#include "AEE.h"
#include "AEEInterface.h"


/*@------------------------------------------------------------------------------------------
   Constant Declarations
-------------------------------------------------------------------------------------------*/
/*@ KADDR_PARM_XXX */
#define KADDR_PARM_LASTMODIFY       (0)   /*@ ŏIXV */
#define KADDR_PARM_GROUPNO          (1)   /*@ O[vԍ */
#define KADDR_PARM_SECRET           (2)   /*@ V[Nbgݒ(0:Off, 1:On) */
#define KADDR_PARM_NAME             (3)   /*@     */
#define KADDR_PARM_YOMI             (4)   /*@     */
#define KADDR_PARM_TELNO1           (5)   /*@ dbԍP */
#define KADDR_PARM_TELNO2           (6)   /*@ dbԍQ */
#define KADDR_PARM_TELNO3           (7)   /*@ dbԍR */
#define KADDR_PARM_EMAILADDR1       (8)   /*@ E[AhXP */
#define KADDR_PARM_EMAILADDR2       (9)   /*@ E[AhXQ */
#define KADDR_PARM_EMAILADDR3       (10)  /*@ E[AhXR */
#define KADDR_PARM_EXTENSIONNO1     (11)  /*@ ԍP */
#define KADDR_PARM_EXTENSIONNO2     (12)  /*@ ԍQ */
#define KADDR_PARM_IMADDR           (13)  /*@ IMAhX */
#define KADDR_PARM_BIRTHDAY         (14)  /*@ a(YYYYMMDD`) */
#define KADDR_PARM_HOBBY            (15)  /*@     */
#define KADDR_PARM_ADDRESS          (16)  /*@ Z    */
#define KADDR_PARM_URL              (17)  /*@ URL     */
#define KADDR_PARM_MEMO             (18)  /*@     */
#define KADDR_PARM_CONSTELLATION    (19)  /*@     */
#define KADDR_PARM_BLOOD            (20)  /*@ t^  */
#define KADDR_PARM_LOCATION         (21)  /*@ ʒu*/
#define KADDR_PARM_PHOTO            (22)  /*@ PHOTOit@Cj */
#define KADDR_PARM_POSTALNO         (23)  /*@ X֔ԍ*/
#define KADDR_PARM_ORGANIZATION     (24)  /*@ gD*/
#define KADDR_PARM_SECTION          (25)  /*@     */


/*@------------------------------------------------------------------------------------------
   Type Declarations
-------------------------------------------------------------------------------------------*/
/*@ KDDIAddrTelAttr */
#define KDDIADDRTELATTR_OTHER       (0)   /*@ ̑ */
#define KDDIADDRTELATTR_CELLULAR    (1)   /*@ g   */
#define KDDIADDRTELATTR_PHS         (2)   /*@ PHS    */
#define KDDIADDRTELATTR_HOME        (3)   /*@    */
#define KDDIADDRTELATTR_OFFICE      (4)   /*@ d   */
#define KDDIADDRTELATTR_FAX         (5)   /*@ FAX    */

typedef  uint32   KDDIAddrTelAttr;

/*@ KDDIAddrEmailAttr */
#define KDDIADDREMAILATTR_OTHER     (0)   /*@ ̑ */
#define KDDIADDREMAILATTR_CELLULAR  (1)   /*@ g   */
#define KDDIADDREMAILATTR_PHS       (2)   /*@ PHS    */
#define KDDIADDREMAILATTR_HOME      (3)   /*@    */
#define KDDIADDREMAILATTR_SCHOOL    (4)   /*@ wZ   */
#define KDDIADDREMAILATTR_OFFICE    (5)   /*@ d   */

typedef  uint32   KDDIAddrEmailAttr;

/*@ KDDIAddrLocationAttr */
#define KDDIADDRLOCATIONATTR_OTHER  (0)   /*@ ̑ */
#define KDDIADDRLOCATIONATTR_HOME   (1)   /*@    */
#define KDDIADDRLOCATIONATTR_WORK   (2)   /*@    */

typedef  uint32   KDDIAddrLocationAttr;

/*@ KDDIAddrBlood */
#define KDDIADDRBLOOD_NULL          (0)   /*@ IȂ*/
#define KDDIADDRBLOOD_A             (1)   /*@ A^     */
#define KDDIADDRBLOOD_B             (2)   /*@ B^     */
#define KDDIADDRBLOOD_O             (3)   /*@ O^     */
#define KDDIADDRBLOOD_AB            (4)   /*@ AB^    */

typedef  uint32   KDDIAddrBlood;

/*@ KDDIAddrCons */
#define KDDIADDRCONS_NULL           (0)   /*@ IȂ*/
#define KDDIADDRCONS_ARIES          (1)   /*@ r  */
#define KDDIADDRCONS_TAURUS         (2)   /*@   */
#define KDDIADDRCONS_GEMINI         (3)   /*@ oq  */
#define KDDIADDRCONS_CANCER         (4)   /*@ I    */
#define KDDIADDRCONS_LEO            (5)   /*@ q  */
#define KDDIADDRCONS_VIRGO          (6)   /*@   */
#define KDDIADDRCONS_LIBRA          (7)   /*@ V  */
#define KDDIADDRCONS_SCORPIO        (8)   /*@ 嶍    */
#define KDDIADDRCONS_SAGITTARIUS    (9)   /*@ ˎ  */
#define KDDIADDRCONS_CAPRICORN      (10)  /*@ Rr  */
#define KDDIADDRCONS_AQUARIUS       (11)  /*@ r  */
#define KDDIADDRCONS_PISCES         (12)  /*@     */
#define KDDIADDRCONS_OPHIUCHUS      (13)  /*@ ֌  */

typedef  uint32   KDDIAddrCons;

typedef struct _KDDIAddrBookInfo{
   uint16  wMaxMemNo;                     /*@ ő僁ԍ */
   uint16  wResisteredRecord;             /*@ o^ς݃R[h */
   uint16  wSelectableRecord;             /*@ w肳ꂽtB[h񂪓o^Ă郌R[h̐ */
} KDDIAddrBookInfo;

typedef struct _KDDIMemoryNoStatus{
   uint16  wStatus;                       /*@ R[h */
   uint32  dwLastModify;                  /*@ ŏIXV */
} KDDIMemoryNoStatus;

typedef void(* PFNADDRRECORDCB)(void * pUser, uint16 wMemoryNum, uint32 dwPropertyID, int nError);

typedef struct IKDDIAddrBook  IKDDIAddrBook;
typedef struct IKDDIAddrRec   IKDDIAddrRec;

/*@------------------------------------------------------------------------------------------
   Macros Declarations
-------------------------------------------------------------------------------------------*/

/*@==========================================================================================
 FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
===========================================================================================*/
/*@------------------------------------------------------------------------------------------
   IKDDIAddrBook Interface
-------------------------------------------------------------------------------------------*/
/*@------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IKDDIAddrBook)
{
   INHERIT_IBase(IKDDIAddrBook);
   int     (* SetRecord)      (IKDDIAddrBook * pIAddrBook, IKDDIAddrRec * pIAddrRec, uint16 wMemoryNo, boolean bUpdate);
   int     (* GetRecord)      (IKDDIAddrBook * pIAddrBook, uint16 wMemoryNo, IKDDIAddrRec ** ppIAddrRec);
   int     (* SearchRecords)  (IKDDIAddrBook * pIAddrBook, uint16 nSearchMode, char * pInbuf, uint16 * pMemArray, uint32 * pdwArraySize, char * pszOption);
   int     (* GetGroupName)   (IKDDIAddrBook * pIAddrBook, uint16 wGroupNum, char * pszGroupName, int * pnSize);
   int     (* GetMemNoStatus) (IKDDIAddrBook * pIAddrBook, KDDIMemoryNoStatus * pKMemoryNoStatus);
   int     (* Remove)         (IKDDIAddrBook * pIAddrBook, uint16 wMemoryNo);
   boolean (* HandleEvent)    (IKDDIAddrBook * pIAddrBook, AEEEvent evt, uint16 wp, uint32 dwp);
   int     (* SelectUI)       (IKDDIAddrBook * pIAddrBook, PFNADDRRECORDCB pfn, void * pUser, char * pszOption);
   int     (* GetInfo)        (IKDDIAddrBook * pIAddrBook, KDDIAddrBookInfo * pKAddrBookInfo, char * pszOption);
};

/*@------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IKDDIADDRBOOK_AddRef(p)                                 AEEGETPVTBL((p),IKDDIAddrBook)->AddRef((p))
#define IKDDIADDRBOOK_Release(p)                                AEEGETPVTBL((p),IKDDIAddrBook)->Release((p))
#define IKDDIADDRBOOK_SetRecord(p, pAR, wM, bU)                 AEEGETPVTBL((p),IKDDIAddrBook)->SetRecord((p), (pAR), (wM), (bU))
#define IKDDIADDRBOOK_GetRecord(p, wM, ppAR)                    AEEGETPVTBL((p),IKDDIAddrBook)->GetRecord((p), (wM), (ppAR))
#define IKDDIADDRBOOK_SearchRecords(p, nS, pIn, pM, pdwA, pszO) AEEGETPVTBL((p),IKDDIAddrBook)->SearchRecords((p), (nS), (pIn), (pM), (pdwA), (pszO))
#define IKDDIADDRBOOK_GetGroupName(p, wG, pszG, pnS)            AEEGETPVTBL((p),IKDDIAddrBook)->GetGroupName((p), (wG), (pszG), (pnS))
#define IKDDIADDRBOOK_GetMemNoStatus(p, pMNS)                   AEEGETPVTBL((p),IKDDIAddrBook)->GetMemNoStatus((p), (pMNS))
#define IKDDIADDRBOOK_Remove(p, wM)                             AEEGETPVTBL((p),IKDDIAddrBook)->Remove((p), (wM))
#define IKDDIADDRBOOK_HandleEvent(p, ev, wp, dwp)               AEEGETPVTBL((p),IKDDIAddrBook)->HandleEvent((p), (ev), (wp), (dwp))
#define IKDDIADDRBOOK_SelectUI(p, pfn, pU, pszO)                AEEGETPVTBL((p),IKDDIAddrBook)->SelectUI((p), (pfn), (pU), (pszO))
#define IKDDIADDRBOOK_GetInfo(p, pABI, pszO)                    AEEGETPVTBL((p),IKDDIAddrBook)->GetInfo((p), (pABI), (pszO))


/*@------------------------------------------------------------------------------------------
   IKDDIAddrRec Interface
-------------------------------------------------------------------------------------------*/
/*@------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IKDDIAddrRec)
{
   INHERIT_IBase(IKDDIAddrRec);
   int     (* SetProp) (IKDDIAddrRec * pIAddrRec, uint32 dwPropertyID, int32 p1, int32 p2);
   int     (* GetProp) (IKDDIAddrRec * pIAddrRec, uint32 dwPropertyID, int32 * p1, int32 * p2);
};

/*@------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IKDDIADDRREC_AddRef(p)               AEEGETPVTBL((p),IKDDIAddrRec)->AddRef((p))
#define IKDDIADDRREC_Release(p)              AEEGETPVTBL((p),IKDDIAddrRec)->Release((p))
#define IKDDIADDRREC_SetProp(p, dwP, p1, p2) AEEGETPVTBL((p),IKDDIAddrRec)->SetProp((p), (dwP), (p1), (p2))
#define IKDDIADDRREC_GetProp(p, dwP, p1, p2) AEEGETPVTBL((p),IKDDIAddrRec)->GetProp((p), (dwP), (p1), (p2))


#endif /*@ End of IKDDIADDRBOOK_H */

