#ifndef IKDDICALENDAR_H
#define IKDDICALENDAR_H
/*@==========================================================================================

FILE            : IKDDICalendar.h

SERVICES        : IKDDICalendar Access Interface

DESCRIPTION     :

PUBLIC CLASSES  :

INITIALIZATION AND SEQUENCING REQUIREMENTS :

      Copyright  1999-2005 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

===========================================================================================*/

/*@==========================================================================================

                        EDIT HISTORY FOR MODULE

When        Who    Keyword             what, where, why
----------  -----  ------------------  ------------------------------------------------------
11/29/05                               Create file
===========================================================================================*/

/*@==========================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
===========================================================================================*/
/*@------------------------------------------------------------------------------------------
   Defines
-------------------------------------------------------------------------------------------*/

/*@------------------------------------------------------------------------------------------
   Include Files
-------------------------------------------------------------------------------------------*/
#include "AEE.h"
#include "AEEInterface.h"


/*@------------------------------------------------------------------------------------------
   Constant Declarations
-------------------------------------------------------------------------------------------*/
/*@ KDDINullTime */
#define KDDICALNULLTIME                 (0xFFFFFFFF)

#define KDDICALWEEK_NULL                (0)
#define KDDICALWEEK_SUN                 (1)
#define KDDICALWEEK_MON                 (2)
#define KDDICALWEEK_TUE                 (4)
#define KDDICALWEEK_WED                 (8)
#define KDDICALWEEK_THR                 (16)
#define KDDICALWEEK_FRI                 (32)
#define KDDICALWEEK_SAT                 (64)

/*@ KCAL_PARM_XXX */
#define KCAL_PARM_LASTMODIFIED          (0)   /*@ ŏIXV */
#define KCAL_PARM_STARTDATE             (1)   /*@ Jn   */
#define KCAL_PARM_STARTTIME             (2)   /*@ Jn */
#define KCAL_PARM_ENDDATE               (3)   /*@ I   */
#define KCAL_PARM_ENDTIME               (4)   /*@ I */
#define KCAL_PARM_ALLDAY                (5)   /*@ ItO On/Off */
#define KCAL_PARM_DESCRIPTION           (6)   /*@ p() */
#define KCAL_PARM_LOCATION              (7)   /*@ ꏊ     */
#define KCAL_PARM_SUMMARY               (8)   /*@      */
#define KCAL_PARM_CATEGORIES            (9)   /*@ JeS */
#define KCAL_PARM_URL                   (10)  /*@ URL  */
#define KCAL_PARM_XKDDIPHOTO            (11)  /*@ 摜     */
#define KCAL_PARM_RECURPATTERN          (12)  /*@ JԂp^[(/T//N/Ǝ) */
#define KCAL_PARM_RECURCOUNT            (13)  /*@ JԂ(0,1`99)0͖(Opt) */
#define KCAL_PARM_SECRET                (14)  /*@ V[Nbg On/Off */
#define KCAL_PARM_ALARM                 (15)  /*@ A[On/Off */
#define KCAL_PARM_EXCEPTION             (16)  /*@ |     */
#define KCAL_PARM_OEMPARM               (128) /*@ ȍ~OEMƎɒ` */

/*@------------------------------------------------------------------------------------------
   Type Declarations
-------------------------------------------------------------------------------------------*/
/*@ KDDICalCategory */
#define KDDICALCATEGORY_NULL            (0)
#define KDDICALCATEGORY_BUSINESS        (1)
#define KDDICALCATEGORY_PERSONAL        (2)
#define KDDICALCATEGORY_EDUCATION       (3)
#define KDDICALCATEGORY_HOLIDAY         (4)
#define KDDICALCATEGORY_MISCELLANEOUS   (5)
#define KDDICALCATEGORY_MEETING         (6)
#define KDDICALCATEGORY_TRAVEL          (7)
#define KDDICALCATEGORY_KDDIEMOJI       (8)
#define KDDICALCATEGORY_OEM             (128)

typedef uint32 KDDICalCategory;

/*@ KDDICalRecurPattern */
#define KDDICALRECUREPATTERN_NULL       (0)
#define KDDICALRECUREPATTERN_DAY        (1)
#define KDDICALRECUREPATTERN_WEEK       (2)
#define KDDICALRECUREPATTERN_MONTH      (3)
#define KDDICALRECUREPATTERN_YEAR       (4)
#define KDDICALRECUREPATTERN_OEM        (128)

typedef uint32 KDDICalRecurPattern;

typedef uint32 KDDICalItemID;
typedef uint32 KDDICalDate;
typedef uint32 KDDICalTime;

typedef struct _KDDICalItemIDList
{
   KDDICalItemID   dwItemID;         /*@ ItemID */
   uint32          dwLastUpdate;     /*@ ŏIXV */
} KDDICalItemIDList;


typedef struct IKDDICalMgr     IKDDICalMgr;
typedef struct IKDDICalendar   IKDDICalendar;

/*@------------------------------------------------------------------------------------------
   Macros Declarations
-------------------------------------------------------------------------------------------*/

/*@==========================================================================================
 FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
===========================================================================================*/
/*@------------------------------------------------------------------------------------------
   IKDDICalMgr Interface
-------------------------------------------------------------------------------------------*/
/*@------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IKDDICalMgr)
{
   INHERIT_IBase(IKDDICalMgr);
   int     (* SetItem)     (IKDDICalMgr * pICalMgr, IKDDICalendar * pICal, KDDICalItemID * pdwItemID);
   int     (* Remove)      (IKDDICalMgr * pICalMgr, KDDICalItemID dwItemID);
   int     (* GetItemList) (IKDDICalMgr * pICalMgr, uint16 wYear, uint16 wMonth, uint32 * pdwArraySize, KDDICalItemIDList * pIDArray);
   int     (* GetItemByID) (IKDDICalMgr * pICalMgr, KDDICalItemID dwItemID, IKDDICalendar ** ppICal);
};

/*@------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IKDDICALMGR_AddRef(p)                           AEEGETPVTBL((p),IKDDICalMgr)->AddRef((p))
#define IKDDICALMGR_Release(p)                          AEEGETPVTBL((p),IKDDICalMgr)->Release((p))
#define IKDDICALMGR_SetItem(p, pC, pdwID)               AEEGETPVTBL((p),IKDDICalMgr)->SetItem((p), (pC), (pdwID))
#define IKDDICALMGR_Remove(p, dwID)                     AEEGETPVTBL((p),IKDDICalMgr)->Remove((p), (dwID))
#define IKDDICALMGR_GetItemList(p, wY, wM, pdwAS, pIDA) AEEGETPVTBL((p),IKDDICalMgr)->GetItemList((p), (wY), (wM), (pdwAS), (pIDA))
#define IKDDICALMGR_GetItemByID(p, dwID, ppCA)          AEEGETPVTBL((p),IKDDICalMgr)->GetItemByID((p), (dwID), (ppCA))

/*@------------------------------------------------------------------------------------------
   IKDDICalendar Interface
-------------------------------------------------------------------------------------------*/
/*@------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IKDDICalendar)
{
   INHERIT_IBase(IKDDICalendar);
   int     (* SetProp) (IKDDICalendar * pICal, uint32 dwPropertyID, int32 p1, int32 p2);
   int     (* GetProp) (IKDDICalendar * pICal, uint32 dwPropertyID, int32 * p1, int32 * p2);
};

/*@------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IKDDICALENDAR_AddRef(p)               AEEGETPVTBL((p),IKDDICalendar)->AddRef((p))
#define IKDDICALENDAR_Release(p)              AEEGETPVTBL((p),IKDDICalendar)->Release((p))
#define IKDDICALENDAR_SetProp(p, dwP, p1, p2) AEEGETPVTBL((p),IKDDICalendar)->SetProp((p), (dwP), (p1), (p2))
#define IKDDICALENDAR_GetProp(p, dwP, p1, p2) AEEGETPVTBL((p),IKDDICalendar)->GetProp((p), (dwP), (p1), (p2))


#endif /*@ End of IKDDICALENDAR_H */

