#ifndef IKDDIMFUNC_H
#define IKDDIMFUNC_H
/*===========================================================================================

FILE            : IKDDIMFUNC.h

DESCRIPTION     :

PUBLIC CLASSES  :

INITIALIZATION AND SEQUENCING REQUIREMENTS :

      Copyright  1999-2005 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

===========================================================================================*/

/*===========================================================================================

                        EDIT HISTORY FOR MODULE

When        Who    Keyword             what, where, why
----------  -----  ------------------  ------------------------------------------------------
09/12/05                               Create file
===========================================================================================*/

/*===========================================================================================
 INCLUDES AND VARIABLE DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Defines
-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------
   Include Files
-------------------------------------------------------------------------------------------*/
#include "AEE.h"
#include "AEEInterface.h"

/*-------------------------------------------------------------------------------------------
   Constant Declarations
-------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------
   Type Declarations
-------------------------------------------------------------------------------------------*/
enum {
   IKDDIMFN_UNKNOWN = 0,
   IKDDIMFN_CHANGE_LOCK_NO,
   IKDDIMFN_RESTRICT_HANDSET,
   IKDDIMFN_RESTRICT_ORIGINATION,
   IKDDIMFN_RESTRICT_ADDRBOOK,
   IKDDIMFN_RESTRICT_EMAIL,
   IKDDIMFN_RESTRICT_CMAIL,
   IKDDIMFN_RESTRICT_EZWEB,
   IKDDIMFN_LAST
};
#ifdef WIN32
typedef unsigned KDDIMFuncItem;
#else
typedef byte KDDIMFuncItem;
#endif



typedef struct IKDDIMFunc IKDDIMFunc;

/*-------------------------------------------------------------------------------------------
   Macros Declarations
-------------------------------------------------------------------------------------------*/

/*===========================================================================================
 FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
===========================================================================================*/
/*-------------------------------------------------------------------------------------------
   Interface Definitions
-------------------------------------------------------------------------------------------*/
AEEINTERFACE(IKDDIMFunc)
{
   INHERIT_IBase(IKDDIMFunc);
   int     (* Set)     (IKDDIMFunc * pIMFunc, KDDIMFuncItem nItem, void * pBuff, int nSize);
   int     (* Get)     (IKDDIMFunc * pIMFunc, KDDIMFuncItem nItem, void * pBuff, int * pnSize);
};

/*-------------------------------------------------------------------------------------------
   Access Macros
-------------------------------------------------------------------------------------------*/
#define IKDDIMFUNC_AddRef(p)                         AEEGETPVTBL((p),IKDDIMFunc)->AddRef((p))
#define IKDDIMFUNC_Release(p)                        AEEGETPVTBL((p),IKDDIMFunc)->Release((p))
#define IKDDIMFUNC_Set(p, nI, pB, nS)                AEEGETPVTBL((p),IKDDIMFunc)->Set(p, nI, pB, nS)
#define IKDDIMFUNC_Get(p, nI, pB, pn)                AEEGETPVTBL((p),IKDDIMFunc)->Get(p, nI, pB, pn)


/*===========================================================================================
   DATA STRUCTURE DOCUMENTATION
=============================================================================================
=============================================================================================

    M@\p[^̒`

    nItem                                                       ^      l
1   IKDDIMFN_CHANGE_LOCK_NO         bNNo.ύXi4`8j1  char    ASCIIZ
                                                                            Fh1234h
2   IKDDIMFN_RESTRICT_HANDSET       I[gbNON/OFF3         uint16  ݒONiăbNONj F2
                                                                            ݒONiăbNOFFjF1
                                                                            ݒOFFF0
3   IKDDIMFN_RESTRICT_ORIGINATION   _CMON/OFF          uint16  ݒON F1
                                                                            ݒOFFF0
4   IKDDIMFN_RESTRICT_ADDRBOOK      AhXON/OFF            uint16  ݒON F1
                                                                            ݒOFFF0
5   IKDDIMFN_RESTRICT_EMAIL         E[ON/OFF2          uint16  ݒON F1
                                                                            ݒOFFF0
6   IKDDIMFN_RESTRICT_CMAIL         C[ON/OFF2          uint16  ݒON F1
                                                                            ݒOFFF0
7   IKDDIMFN_RESTRICT_EZWEB         EZwebON/OFF                 uint16  ݒON F1
                                                                            ݒOFFF0


=============================================================================================
=============================================================================================
   INTERFACE DOCUMENTATION
=============================================================================================
TODO
*/
#endif // IKDDIMFUNC_H

