#ifndef IKDDINAVI_H
#define IKDDINAVI_H /* #ifndef IKDDINAVI_H */
/*============================================================================

FILE:  IKDDINAVI.h

SERVICES:


GENERAL DESCRIPTION:


REVISION HISTORY:

============================================================================

               Copyright  1999-2003 QUALCOMM Incorporated
                       All Rights Reserved.
                   QUALCOMM Proprietary/GTDR

============================================================================*/
/*===============================================================================
    INCLUDES AND VARIABLE DEFINITIONS
===============================================================================*/

/*-------------------------------------------------------------------
      Include Files
-------------------------------------------------------------------*/
#include "AEE.h"
#include "KDDINAVI.bid"

/*-------------------------------------------------------------------
      Type Declarations
-------------------------------------------------------------------*/

//
// GPS Restriction
//
#define AEEKDDI_GPS_ALLOWED         0              // imFj
#define AEEKDDI_GPS_VERIFY          1              // mF
#define AEEKDDI_GPS_RESTRICTED      2              // s

//
// Postion Information
//
#define AEEKDDI_MAX_TITLE_LENGTH    80             // ő^Cg
#define AEEKDDI_MAX_LAT_LENGTH      12             // őox
#define AEEKDDI_MAX_LON_LENGTH      13             // őܓx

typedef struct _KDDI_POSITION_INFO {
   uint32 dwResult;                                // 
   char   szTitle[AEEKDDI_MAX_TITLE_LENGTH+1];     // ^Cg
   byte   datum;                                   // ʌn
   byte   unit;                                    // vtH[}bg
   char   szLat[AEEKDDI_MAX_LAT_LENGTH +1];        // ox
   char   szLon[AEEKDDI_MAX_LON_LENGTH +1];        // ܓx
   byte   fm;                                      // ʃ[h
} KDDI_POSITION_INFO;

// Postion Information Result
#define KDDINAVI_RESULT_SUCCESS     0              // 
#define KDDINAVI_RESULT_FAILED      1              // s


//-------------------------------------------------------------------
// Interface Definitions
//-------------------------------------------------------------------

typedef struct IKDDINAVI IKDDINAVI;

//********************************************************************************************************************************
//
// IKddiNavi Interface
//
//********************************************************************************************************************************

AEEINTERFACE(IKDDINAVI) {
   DECLARE_IBASE(IKDDINAVI)
   int (*GetGpsRestriction)(IKDDINAVI *pIKddiNavi, uint16 *pwRestriction);
   int (*GetTargetInfo)    (IKDDINAVI *pIKddiNavi, void **ppTargetInfo);
   int (*WritePositionData)(IKDDINAVI *pIKddiNavi, AEEEvent EventCode, KDDI_POSITION_INFO *pPositionInfo, void *pTargetInfo, boolean bClose);
   int (*ReadPositionData) (IKDDINAVI *pIKddiNavi, AEEEvent EventCode, KDDI_POSITION_INFO *pPositionInfo, void **ppTargetInfo);
   int (*WriteMySpot)      (IKDDINAVI *pIKddiNavi, AEEEvent EventCode, KDDI_POSITION_INFO *pPositionInfo, void **ppTargetInfo);
};

// Access Macros for IKddiNavi interface

#define IKDDINAVI_AddRef(p)                              AEEGETPVTBL((p),IKDDINAVI)->AddRef((p))
#define IKDDINAVI_Release(p)                             AEEGETPVTBL((p),IKDDINAVI)->Release((p))
#define IKDDINAVI_GetGpsRestriction(p, pw)               AEEGETPVTBL((p),IKDDINAVI)->GetGpsRestriction(p, pw)
#define IKDDINAVI_GetTargetInfo(p, ppTI)                 AEEGETPVTBL((p),IKDDINAVI)->GetTargetInfo((p), (ppTI))
#define IKDDINAVI_WritePositionData(p, e, pPI, pTI, b)   AEEGETPVTBL((p),IKDDINAVI)->WritePositionData(p, e, pPI, pTI, b)
#define IKDDINAVI_ReadPositionData(p, e, pPI, ppTI)      AEEGETPVTBL((p),IKDDINAVI)->ReadPositionData(p, e, pPI, ppTI)
#define IKDDINAVI_WriteMySpot(p, e, pPI, ppTI)           AEEGETPVTBL((p),IKDDINAVI)->WriteMySpot(p, e, pPI, ppTI)



/*=====================================================================
  DATA STRUCTURE DOCUMENTATION
=======================================================================
=======================================================================

KDDI_POSITION_INFO

Description:
   IKDDINAVIC^tFCXAPIlCeBuƌʒúAL
   \̂pB
   {\̂́Aʂtitle񂪊܂܂B

Definition:

typedef struct _KDDI_POSITION_INFO {
   uint32 dwResult;                                // 
   char   szTitle[AEEKDDI_MAX_TITLE_LENGTH+1];     // ^Cg
   byte   datum;                                   // ʌn
   byte   unit;                                    // vtH[}bg
   char   szLat[AEEKDDI_MAX_LAT_LENGTH +1];        // ox
   char   szLon[AEEKDDI_MAX_LON_LENGTH +1];        // ܓx
   byte   fm;                                      // ʃ[h
} KDDI_POSITION_INFO;

Members:
   dwResult: 
   szAdd   : 0x00I[add(񂪑݂Ȃꍇ́A擪̃oCg0x00I[Ƃ)
   datum   :g0h WSG-84ʌn
            g1h Tokyo({)ʌn
   unit    :g0h dms(xEEb)
            g1h degree
   szLat   : 0x00I[̈ܓx  +35.12.34.56/+135.12345
   szLon   : 0x00I[̌ox  +135.12.34.56/+135.123456
   fm      : ʃ[h
            g0hGPS-Fix
            g1hHybrid-Fix
            g2hAFLT-Fix
            g3hBS Region
            g4hCall Sector Center
            g5hPre-Fix

Comments:
   None

Side Effects:
   None
=======================================================================

=======================================================================
INTERFACES   DOCUMENTATION
=======================================================================
Interface Name: IKddiNavi

Description:
   IKDDINAVIC^tFCX́ABREW2.1KDDIJX^}CYƂĒǉB
   
   ̃C^tFCXgpɂ́uPosdetv͑SĂ̓x
   ݒ肷Kv܂B
   
List of functions
   ̃C^tFCXɂ͈ȉ̊֐܂܂B
   IKDDINAVI_AddRef
   IKDDINAVI_ReadPositionData
   IKDDINAVI_Release

===========================================================================

Function: IKDDINAVI_AddRef()

Description:
   ̊֐ IKDDINAVIC^tF[XIuWFNg̎QƃJEg𑝂₷B
   ͌ĂяȍꍇɃIuWFNgL邱ƂeB

Prototype:
   uint32 IKDDINAVI_AddRef(IKDDINAVI *pIKddiNavi)

Parameters:
   pIKddiNavi: Pointer to the IKDDINAVI Interface object.

Return Value:
   ̃IuWFNgɑ΂QƃJEg

Comments:
   IuWFNgLłΐ̒lԂ.

Side Effects:
   None

See Also:
   IKDDINAVI_Release()
===========================================================================

Function: IKDDINAVI_ReadPositionData()

Description:
   lCeBuɑJڂĈʒuf[^擾B

Prototype:
   int IKDDINAVI_ReadPositionData(IKDDINAVI *pIKddiNavi,
                                  AEEEvent EventCode,
                                  KDDI_POSITION_INFO *pPositionInfo,
                                  void **ppTargetInfo)

Parameters:
   pIKddiNavi   : IKDDINAVIIuWFNgւ̃|C^
   EventCode    : ɒʒmCxg(EVT_APP_USERȏ̒lw)
   pPositionInfo: 擾ʂi[̈
   ppTargetInfo : 擾Ώۏ񂪊i[Ă|C^i[̈ւ̃|C^

Return Value:
   KDDI_SUCCESS    - 
   KDDI_EFAILED    - s
   KDDI_EBADPARAM  - sȃp[^
   KDDI_EPRIVLEVEL - xs

Comments:
   {APIĂяoꍇAAvbg̓TXygB
   ʂ"pPositionInfo"̈ɕԋpB
   Ƀf[^ԋp̂́Aw肵CxgʒmꂽƂłB
   TXyh́AlCeBuUIɑJڂAL̏ꏊʒuf[^擾邱ƂłB
   }CX|bgXg
   AhX
   vtB[
   f[^tH_

   lCeBuUIɑJڂȀ̏ICxgʒmꂽꍇAKDDI_POSITION_INFO
   ̃ołdwResultɏʂi[ĂB
   KDDINAVI_RESULT_SUCCESS  擾
   KDDINAVI_RESULT_FAILED   擾s


Side Effects:
   None

See Also:
   None
===========================================================================

Function: IKDDINAVI_Release()

Description:
   ̊֐IKDDINAVIC^tF[XIuWFNg̎QƃJEg炷B
   QƃJEgOi[jɒBAIuWFNg̓AƂȂB

Prototype:
   uint32 IKDDINAVI_Release(IKDDINAVI *pIKddiNavi)

Parameters:
   pIKddiNavi: Pointer to the IKDDINAVI Interface object.

Return Value:
   QƃJEg: ̃IuWFNgɑ΂QƃJEg
   Oi[j  : IuWFNgɉꖳƂȂĂꍇ

Comments:
   None

Side Effects:
   None

See Also:
   IKDDINAVI_AddRef()
===========================================================================*/


#endif /* #ifndef IKDDINAVI_H */



