/// @file FILE            : INATIVE.h
///
/// @brief SERVICES        : INATIVE Interface 
///
/// @brief DESCRIPTION     : INATIVE Interface  Header
///
/// @brief Brew䕔AvǗ̎qAv(Adaptor)ɑ΂CxgʒmT[rX񋟂܂B
///
///yINATIVEKCPBRIGEɔzMĂCxgz
///
///	KPADP_CREATE_Req,         // INATIVE_Init()
///	KPADP_RELEASE_Req,        // INATIVE_Release()	
///	KPADP_START_Req,          // INATIVE_Start()
///	KPADP_SUSPENReq,          // INATIVE_Suspend()
///	KPADP_RESUME_Req,         // INATIVE_Resume()
///	KPADP_ENDKEY_Req,         // INATIVE_EndKey()
///	KPADP_STOP_Req,           // INATIVE_Stop()
///	KPADP_SHUTDOWN_Req,       // INATIVE_Shutdown()
///	KPADP_TERMSTATUSNOTIFY,   // INATIVE_TermStatusNotify()
///	KPADP_SYNCEVENT,          // INATIVE_SendEvent()
///	KPADP_ASYNCEVENT,         // INATIVE_PostEvent()
///	KPADP_RESULT              // INATIVE_Result()
///
///     (C) Copyright 2005 Sony Ericsson Mobile Communications Japan, Inc.
///

#ifndef INATIVE_H
#define INATIVE_H

#include "AEEComdef.h"
#include "AEE.h"
#include "INATIVE.bid"



//CX^X̃^Cv錾
typedef struct _INATIVE INATIVE;

QINTERFACE(INATIVE)
{
	//AddRefRelease錾
	DECLARE_IBASE(INATIVE)

	//ȉgAPI`
	int (*init)( INATIVE *po, AEECLSID cls, uint16 wParam, uint32 dwParam );
	int (*start)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*suspend)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*resume)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*stop)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*endkey)( INATIVE *po );
	int (*shutdown)( INATIVE *po );
	int (*termstatusnotify)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*sendevent)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*postevent)( INATIVE *po, uint16 wParam, uint32 dwParam );
	int (*result)( INATIVE *po, boolean beSuccess, uint32 Reason );
	
};

#if !defined DOCUMENTATION

#define INATIVE_AddRef(p) GET_PVTBL(p,INATIVE)->AddRef(p)
#define INATIVE_Release(p) GET_PVTBL(p,INATIVE)->Release(p)
#define INATIVE_Init(p,cls,wParam,dwParam) GET_PVTBL(p,INATIVE)->init(p,cls,wParam,dwParam)
#define INATIVE_Start(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->start(p,wParam,dwParam)
#define INATIVE_Suspend(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->suspend(p,wParam,dwParam)
#define INATIVE_Resume(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->resume(p,wParam,dwParam)
#define INATIVE_Stop(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->stop(p,wParam,dwParam)
#define INATIVE_EndKey(p) GET_PVTBL(p,INATIVE)->endkey(p)
#define INATIVE_Shutdown(p) GET_PVTBL(p,INATIVE)->shutdown(p)
#define INATIVE_TermStatusNotify(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->termstatusnotify(p,wParam,dwParam)
#define INATIVE_SendEvent(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->sendevent(p,wParam,dwParam)
#define INATIVE_PostEvent(p,wParam,dwParam) GET_PVTBL(p,INATIVE)->postevent(p,wParam,dwParam)
#define INATIVE_Result(p,beSuccess,Reason) GET_PVTBL(p,INATIVE)->result(p,beSuccess,Reason)



#else

uint32 INATIVE_AddRef(INATIVE* po);
uint32 INATIVE_Release(INATIVE* po);

//**********************************************************************
//  int INATIVE_Init( CNATIVE *po, AEECLSID cls, uint16 wParam, uint32 dwParam )
//
//	Inputs
/// @param   cls :NXID
/// @param    wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   ENOMEMORY :ls
/// @retval   EFAILED: sꍇ 
///	Description
///	@brief ADPADPCX^Xv܂B
///	̊֐INATIVECX^XKR[Kv܂B
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_Init( CNATIVE *po, AEECLSID cls, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_Start( INATIVE *po,uint16 wParam, uint32 dwParam )
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPStartv܂B
///	̊֐EVT_APP_STARTMAKADPɒʒmĂB
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_Start( INATIVE *po, AEECLSID cls, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_Suspend( INATIVE *po, uint16 wParam, uint32 dwParam )
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPSuspendv܂B
///	̊֐EVT_APP_SUSPENDMAKADPɒʒmĂB
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_Suspend( INATIVE *po, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_Resume( INATIVE *po, uint16 wParam, uint32 dwParam )
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPResumev܂B
///	̊֐EVT_APP_RESUMEMAKADPɒʒmĂB
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_Resume( INATIVE *po, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_Stop( INATIVE *po, uint16 wParam, uint32 dwParam )
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPStopv܂B
///	̊֐EVT_APP_STOPMAKADPɒʒmĂB
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_Stop( INATIVE *po, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_EndKey( INATIVE *po)
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPEndKeyCxgʒm܂B
///	̊֐EndKeyCxgMAKADPɒʒmĂB
///	̃VXeł͊{IɁAEndKeyCxgBreŵ݂ɒʒm܂B
///	āÃCxgɂNativeւEndKey̒ʒm܂B
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_EndKey( INATIVE *po);

//**********************************************************************
//  int INATIVE_Shutdown( INATIVE *po)
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPShutDownCxgʒm܂B
///	̊֐ShutDownCxgMAKADPɒʒmĂB
///	̃VXeł͊{IɁAShutDownCxgBreŵ݂ɒʒm܂B
///	āÃCxgɂNativeւShutDown̒ʒm܂B
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_Shutdown( INATIVE *po);

//**********************************************************************
//  int INATIVE_TermStatusNotify( INATIVE *po, uint16 wParam, uint32 dwParam );
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
///	@brief ADPɃXe[^XύXƂʒm܂B
///	gppr̓Xe[^XύXʒm󂯂ƂꍇłA
///	̃Xe[^XύXADPɒʒmKvꍇɎgp܂B
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_TermStatusNotify( INATIVE *po, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_SendEvent( INATIVE *po, uint16 wParam, uint32 dwParam );
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
/// @retval   ̑: sꍇ (ADPł̃^[l)
///	Description
/// @brief	ADPɓIEventʒm܂B
///	ėpICxgʒm֐łBADPɑ΂ISHELL_SendEvent()ƓpɎgpł܂B
///	̃CxgM͓łB
//**********************************************************************

int INATIVE_SendEvent( INATIVE *po, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_PostEvent( INATIVE *po, uint16 wParam, uint32 dwParam );
//
//	Inputs
/// @param   wParam: [U[f[^
/// @param   dwParam: [U[f[^
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
///	Description
/// @brief	ADPɔ񓯊IEventʒm܂B
///	ėpICxgʒm֐łBADPɑ΂ISHELL_PostEvent()ƓpɎgpł܂B
///	̃CxgM͔񓯊łB
//**********************************************************************

int INATIVE_PostEvent( INATIVE *po, uint16 wParam, uint32 dwParam );

//**********************************************************************
//  int INATIVE_Result( INATIVE *po, boolean beSuccess, uint32 Reason );
//
//	Inputs
/// @param   beSuccess: Adp̗vɑ΂錋
/// @param   Reason: ڍ׏([U[ɂĎRɒ`\)
///	Outputs
/// @retval   SUCCESS : Iꍇ
/// @retval   EBADSTATE :INATIVE_Init()s
/// @retval   ENOMEMORY :ls
///	Description
/// @brief	ADP̗vɑ΂錋ʂADPɒʒm܂B(ėpIȌʒʒm)
///	gpprNativẽCxgɑ΂ẴANV̌ʂʒmꍇɎgp܂B
///	̃CxgM͔񓯊łB
//**********************************************************************
int INATIVE_Result( INATIVE *po, boolean beSuccess, uint32 Reason );

#endif
#endif //INATIVE_H
