#ifndef KDDIEDITOR_H
#define KDDIEDITOR_H
/*======================================================
FILE:  KDDIEditor.h

SERVICES:
   KDDI EDITOR Interface

DESCRIPTION:
   This file provides the interface specification for
   the KDDI EDITOR Interface.
   This interface is used to control the Native Editor 
   by IText Control only.
   It is recommeded that this interface is used by IText
   Control class only.

CLASS IDs:

NOTES:

DISTRIBUTION:

        Copyright  1999-2001 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR

=====================================================*/
/* <EJECT> */
/*===========================================================================

                        EDIT HISTORY FOR MODULE

when       who     what, where, why
--------   ---     ----------------------------------------------------------
08/12/04           []
                    KDDI Editor for Berw3.x

===========================================================================*/
/******************************************************************************
//  [PTX-804C]
//		PTX-804 EMUI-20050216001 NJK  p
//		@@@@|[eBOXV
******************************************************************************/

//---------------------------------------------------------------------
// Include Files
//---------------------------------------------------------------------
//PTX-804 EMUI-20050216001 NJK  p
#include "OEMFeatures.h"
//PTX-804 EMUI-20050216001 NJK  p
#include "AEE.h"
#include "AEEVCodes.h"
#include "AEEText.h"
#include "NATIVEEDIT.BID"
//
// MUST include Native editor interface header file here.
//
//#include "Native_Editor.h"

//---------------------------------------------------------------------
// Type Declarations
//---------------------------------------------------------------------
typedef struct _IKDDIEditor IKDDIEditor;

typedef struct  tag_KDDIEDITPARAM {
   AECHAR         * m_pTextBuf;        // [i/o]:Pointer to the Text Edit Buffer
                                       //    [in] :Text data whitch is set to Native Editor's Screen
                                       //    [out]:Text data whitch was edited by Native Editor
   uint16           m_wTextSize;       // [i]  :Size (in bytes) of m_pTextBuf buffer
   uint16           m_wMaxChars;       // [i]  :Maximum text size in AECHAR characters
   AEETextInputMode m_TextInputMode;   // [i/o]:Text Input Mode
                                       //    [i] :Fistst Text Mode
                                       //    [o] :Last Text Mode
   AVKType          m_StartKey;        // [i]  :key code which editor is started by.
   AEEEvent         m_EndEvent;        // [i]  :native editor return event.
//PTX-804 EMUI-20050215001 NJK  p
   AECHAR         * m_pTitle;          // [i]  :Title data whitch is set to Native Editor's Screen
// pX[hݒ蒆̕ҏWAv\u*vɂΉ
   uint32           m_dwProps;         // [i]  :Properties
//PTX-804 EMUI-20050215001 NJK  p
   ITextCtl       * m_pITextCtl;       // [i]  :Pointer of ITectCtl
} KDDIEDITPARAM;


//---------------------------------------------------------------------
// Global Constant Declarations
//---------------------------------------------------------------------
//---------------------------------------------------------------------
// Global Data Declarations
//---------------------------------------------------------------------

//=====================================================================
// FUNCTION DECLARATIONS AND INLINE FUNCTION DEFINITIONS
//=====================================================================
#define KDDI_INHERIT_IKDDIEditor(iname) \
   INHERIT_IBase(iname);\
   boolean            (*HandleEvent)    (iname *, AEEEvent evt, uint16 wParam, uint32 dwParam);\
   boolean            (*Redraw)         (iname *);\
   void               (*Edit_Start)     (iname *, KDDIEDITPARAM *);\
   AEETextInputMode   (*GetInputMode)   (iname *)

//---------------------------------------------------------------------
// IKDDIEditor Interface
//---------------------------------------------------------------------

QINTERFACE(IKDDIEditor)
{
   KDDI_INHERIT_IKDDIEditor(IKDDIEditor);
};

#define IKDDIEDITOR_AddRef(p)                      GET_PVTBL(p,IKDDIEditor)->AddRef(p)
#define IKDDIEDITOR_Release(p)                     GET_PVTBL(p,IKDDIEditor)->Release(p)
#define IKDDIEDITOR_HandleEvent(p,ec,wp,dw)        GET_PVTBL(p,IKDDIEditor)->HandleEvent(p,ec,wp,dw)
#define IKDDIEDITOR_Redraw(p)                      GET_PVTBL(p,IKDDIEditor)->Redraw(p)
#define IKDDIEDITOR_Edit_Start(p,a)                GET_PVTBL(p,IKDDIEditor)->Edit_Start(p,a)
#define IKDDIEDITOR_GetInputMode(p)                GET_PVTBL(p,IKDDIEditor)->GetInputMode(p)

#endif    // KDDIEDITOR_H
