#ifndef _OEMMPUTILDATACTRL_H_
#define _OEMMPUTILDATACTRL_H_
/*======================================================
FILE:  OEMMPUtilDataCtrl.h

SERVICES:
   OEM functions for supporting BREW MPUTIL
   Interface

GENERAL DESCRIPTION:
   This file provides the prorotypes of the functions
   that OEMs must provide in order to support the BREW
   MPUTIL interfaces

=====================================================*/
#include "Common.h"
#include "ApiDlink.h"
#include "ApiDBType.h"
#include "AEEMPUtil.h"
#include "AEEMPUtilOM.h"
#include "AEEMPMulti.h"
#include "OEMMPUtilFileCtrl.h"
#include "ApiMs_AslMsa.h"  //PTX808 MSAudio ASL 

// gbNASgbNi[p
#define GET_TRACK_ALL(a)  a & 0xFF
#define GET_TRACK_NUM(a)  (a >> 16) & 0xFF
#define MAKE_TRACK_INT(num,all) (all & 0xFFFF) | (num << 16)

// 
// TvƎ>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// 

// KMFTvf[^^
typedef struct _KMFSampleData {
    char    TitleName[AEE_MPUTIL_TITLE_NAME_SIZE_MAX];
    char    AlbumName[AEE_MPUTIL_ALBUM_NAME_SIZE_MAX];
    char    ArtistName[AEE_MPUTIL_ARTIST_NAME_SIZE_MAX];
    int     nPlayTime;
    int     nJacketImageCount;
    int     nlyricsImageCount;
    int     nPlayCount;
    int     nRate;
    int32   nPlayLastTime;
    boolean bRegister;
    char    cTrackNum;
    char    cRightPerson[AEE_MPUTIL_RIGHT_PERSON_SIZE_MAX];
    char    cSaleOrigin[AEE_MPUTIL_SALE_ORIGIN_SIZE_MAX];
    char    cMmid[AEE_MPUTIL_MMID_SIZE_MAX];
    KDDIDFDEVICE dev;
    char    szFileName[AEE_MPUTIL_FILENAME_SIZE_MAX];
    int     nWallPaperImageCount;
    int     nDataKind;
    char    cInitial;
    //------------------------vX
    char    KanaTitleName[AEE_MPUTIL_TITLE_NAME_SIZE_MAX];
    char    KanaAlbumName[AEE_MPUTIL_ALBUM_NAME_SIZE_MAX];
    char    KanaArtistName[AEE_MPUTIL_ARTIST_NAME_SIZE_MAX];
    boolean bIsMUIOK;
    // ============N===================
    // A[eBXgN
    struct _KMFSampleData  *ArtistPrev;
    struct _KMFSampleData  *ArtistNext;
    // AoN
    struct _KMFSampleData  *AlbumPrev;
    struct _KMFSampleData  *AlbumNext;
} KMFSampleData;

// Tvf[^Xgm[h
typedef struct _SelectNode {
    struct _SelectNode     *pPrev;
    struct _SelectNode     *pNext;
    struct _KMFSampleData  *pData;
} SelectNode;


// GAXgm[h
typedef struct _AreaNode {
    struct _AreaNode     *pPrev;
    struct _AreaNode     *pNext;
    void                 *pArea;
    int                   nAreaSize;
    char                  szFileName[AEE_MPUTIL_FILENAME_SIZE_MAX];
} AreaNode;

extern boolean	        gIsMSMount;	// MS

// yȃxf[^
/*
extern  SelectNode    *gLabelAA; 	// ""sxꗗ
extern  int            gLabelAACount;
extern  SelectNode    *gLabelKA; 	// ""sxꗗ
extern  int            gLabelKACount;
extern  SelectNode    *gLabelSA; 	// ""sxꗗ
extern  int            gLabelSACount;
extern  SelectNode    *gLabelTA; 	// ""sxꗗ
extern  int            gLabelTACount;
extern  SelectNode    *gLabelNA; 	// ""sxꗗ
extern  int            gLabelNACount;
extern  SelectNode    *gLabelHA; 	// ""sxꗗ
extern  int            gLabelHACount;
extern  SelectNode    *gLabelMA; 	// ""sxꗗ
extern  int            gLabelMACount;
extern  SelectNode    *gLabelYA; 	// ""sxꗗ
extern  int            gLabelYACount;
extern  SelectNode    *gLabelLA; 	// ""sxꗗ
extern  int            gLabelLACount;
extern  SelectNode    *gLabelWA; 	// ""sxꗗ
extern  int            gLabelWACount;
extern  SelectNode    *gLabelabc; 	// "abc"sxꗗ
extern  int            gLabelabcCount;
extern  SelectNode    *gLabeldef; 	// "def"sxꗗ
extern  int            gLabeldefCount;
extern  SelectNode    *gLabelghi; 	// "ghi"sxꗗ
extern  int            gLabelghiount;
extern  SelectNode    *gLabeljkl; 	// "jkl"sxꗗ
extern  int            gLabeljklCount;
extern  SelectNode    *gLabelmno; 	// "mno"sxꗗ
extern  int            gLabelmnoCount;
extern  SelectNode    *gLabelpqrs; 	// "pqrs"sxꗗ
extern  int            gLabelpqrsCount;
extern  SelectNode    *gLabeltuv; 	// "tuv"sxꗗ
extern  int            gLabeltuvCount;
extern  SelectNode    *gLabelwxyz; 	// "wxyz"sxꗗ
extern  int            gLabelwxyzCount;
extern  SelectNode    *gLabelKIGO; 	// "L"sxꗗ
extern  int            gLabelKIGOCount;
extern  SelectNode    *gLabelSONOTA;	// "̑"sxꗗ
extern  int            gLabelSONOTACount;
*/
//-----------------------------------
//**********}NQ*************
//-----------------------------------
/*
// Xg̃e[擾
#define  GET_LISTTAILE( p, next, dt )  { \
    KMFSampleData *_pNode; \
    for ( _pNode = p; _pNode; _pNode = _pNode->##next ) { \
        dt = _pNode; \
    } \
}
// Xg̐擪擾
#define  GET_LISTHEAD( p, prev, dt )  { \
    KMFSampleData *_pNode; \
    for ( _pNode = p; _pNode; _pNode = _pNode->##prev ) { \
        dt = _pNode; \
    } \
}
// Xgi݊yȃXg𐶐
#define  CREATE_SELECTLIST( p, prev, dt, cnt )  { \
    KMFSampleData *_pNode; \
    SelectNode    *_pSelTop = NULL; \
    cnt = 0; \
    for ( _pNode = p; _pNode; _pNode = _pNode->##prev ) { \
        SelectNode* _pSelNode = (SelectNode*)sys_malloc( sizeof( SelectNode ) ); \
        cnt ++; \
        _pSelNode->pData = _pNode; \
        _pSelNode->pPrev = NULL; \
        _pSelNode->pNext = _pSelTop; \
        if ( _pSelTop ) { \
            _pSelTop->pPrev = _pSelNode; \
        } \
        _pSelTop = _pSelNode; \
    }\
    dt = _pSelTop; \
}
// i݊yȃXg𕡐
#define  COPY_SELECTLIST( moto, saki, cnt )  { \
    SelectNode    *_pNode  = NULL; \
    SelectNode    *_pNode2 = NULL; \
    cnt = 0; \
    if ( moto ) { \
        saki = sys_malloc( sizeof( SelectNode ) ); \
        ((SelectNode*)saki)->pPrev = NULL; \
        ((SelectNode*)saki)->pNext = NULL; \
        ((SelectNode*)saki)->pData = moto->pData; \
        _pNode2 = (SelectNode*)saki; \
        for ( _pNode = moto->pNext; _pNode; _pNode = _pNode->pNext ) { \
            SelectNode* _pNewNode = (SelectNode*)sys_malloc( sizeof( SelectNode ) ); \
            _pNewNode->pData = _pNode->pData; \
            _pNewNode->pNext = NULL; \
            _pNewNode->pPrev = _pNode2; \
            _pNode2->pNext   = _pNewNode; \
            _pNode2 = _pNewNode; \
            cnt ++;\
        } \
    } \
}

// i݊yȃXgɃm[h\[gĒǉ
#define  ADDSORT_SELECTLIST( list, node, datastr )  { \
    SelectNode * _pNode = list; \
    SelectNode * _pPrev = NULL; \
    while ( _pNode ) { \
        if ( 0 >= STRCMP( node->pData->##datastr, _pNode->pData->##datastr ) ) { \
            if ( _pPrev ) { \
                _pPrev->pNext = node; \
                node->pPrev   = _pPrev; \
                node->pNext   = _pNode; \
                _pNode->pPrev  = node; \
                break; \
            } \
        } \
        _pPrev = _pNode; \
        _pNode = _pNode->pNext; \
    } \
    if ( NULL == _pNode ) { \
        _pPrev->pNext = node; \
        node->pPrev   = _pPrev; \
        node->pNext   = NULL; \
    } \
}
// i݊yȃXgɃm[h\[gĒǉ
#define  ADDSORTNUM_SELECTLIST( list, node, datastr )  { \
    SelectNode * _pNode = list; \
    SelectNode * _pPrev = NULL; \
    while ( _pNode ) { \
        if ( node->pData->##datastr >= _pNode->pData->##datastr ) { \
            if ( _pPrev ) { \
                _pPrev->pNext = node; \
                node->pPrev   = _pPrev; \
                node->pNext   = _pNode; \
                _pNode->pPrev  = node; \
                break; \
            } \
        } \
        _pPrev = _pNode; \
        _pNode = _pNode->pNext; \
    } \
    if ( NULL == _pNode ) { \
        _pPrev->pNext = node; \
        node->pPrev   = _pPrev; \
        node->pNext   = NULL; \
    } \
}


// i݊yȃXgJ
#define  DELETE_SELECTLIST( p )  { \
    SelectNode    *_pNode = NULL; \
    SelectNode    *_pNext = NULL; \
    for ( _pNode = p; _pNode; _pNode = _pNext ) { \
        _pNext = _pNode->pNext; \
        sys_free( _pNode ); \
    } \
}
// i݊yȃXgm[hO
#define  RELEASE_SELECTNODE( top, nd )  { \
    if ( top == nd ) { \
        top = nd->pNext; \
        if ( NULL != top ) { \
            top->pPrev = NULL; \
        } \
    } else { \
        nd->pPrev->pNext = nd->pNext; \
        if ( NULL != nd->pNext ) { \
            nd->pNext->pPrev = nd->pPrev; \
        } \
    } \
    nd->pNext = NULL; \
    nd->pPrev = NULL; \
}
// i݊yȃXg̎wԍm[h擾
#define  GET_SELECTNODE( top, nd, num )  { \
    int  _i; \
    nd = top; \
    for ( _i = 0; _i != num; _i++ ) { \
        nd = nd->pNext; \
    } \
}
// i݊yȃXg̐K擾
#define  GET_SELECTLISTTAILE( p, dt )  { \
    SelectNode *_pNode; \
    for ( _pNode = p; _pNode; _pNode = _pNode->pNext ) { \
        dt = _pNode; \
    } \
}


// x̃`FbN͈͂擾
#define GET_LABEL_NUM( source, se ) { \
    if ( 0 == STRCMP( source, "" ) ) { se[0][0] = '';  se[0][1]= ''; \
        se[1][0] = '';  se[1][1]= '';\
    } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; \
        se[1][0] = '';  se[1][1]= '';\
    } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; \
        se[1][0] = '';  se[1][1]= '';\
    } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; } \
    else if ( 0 == STRCMP( source, "" ) ) { se[0][0] = ''; se[0][1] = ''; \
        se[1][0] = '';  se[1][1]= '';\
    } \
    else if ( 0 == STRCMP( source, "abc" ) ) { se[0][0] = 'A'; se[0][1] = 'C'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "def" ) ) { se[0][0] = 'D'; se[0][1] = 'E'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "ghi" ) ) { se[0][0] = 'G'; se[0][1] = 'I'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "jkl" ) ) { se[0][0] = 'J'; se[0][1] = 'L'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "mno" ) ) { se[0][0] = 'M'; se[0][1] = 'O'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "pqrs" ) ) { se[0][0] = 'P'; se[0][1] = 'S'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "tuv" ) ) { se[0][0] = 'T'; se[0][1] = 'V'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "wxyz" ) ) { se[0][0] = 'W'; se[0][1] = 'Z'; \
        se[1][0] = se[0][0]+0x20;  se[1][1] = se[0][1] + 0x20;\
    } \
    else if ( 0 == STRCMP( source, "L" ) ) { \
        se[0][0] = '!'; se[0][1] = '/'; \
        se[1][0] = ':'; se[1][1] = '@'; \
        se[2][0] = '['; se[2][1] = '`'; \
        se[3][0] = '{'; se[3][1] = '~'; \
        se[4][0] = ''; se[4][1] = ''; \
    } \
    else if ( 0 == STRCMP( source, "̑" ) ) { \
        se[0][0] = '!'; se[0][1] = '/'; \
        se[1][0] = ':'; se[1][1] = '@'; \
        se[2][0] = ''; se[2][1] = ''; \
        se[3][0] = 'A'; se[3][1] = '~'; \
        se[4][0] = ''; se[4][1] = ''; \
        se[5][0] = ''; se[5][1] = ''; \
    } \
}
*/

// KPLTvf[^^
typedef struct _KPLSampleData {
    char ListName[AEE_MPUTIL_PLNAME_SIZE_MAX];
    int  nListID;
    int  nDataSize;
    KDDIDFDEVICE dev;
    char szFileName[AEE_MPUTIL_FILENAME_SIZE_MAX];
} KPLSampleData;

extern  KPLSampleData *gKPLAll;		// SvCXg

// vCXge[u
typedef struct _S_PlayListTable {
        uint16       Count;                              // vCXg
//        uint16       Index[OEMMPUTIL_MAX_ALL_PLAYLIST];  // vCXgǗf[^Index
}S_PlayListTable;

// 
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<TvƎ
// 


//-----------------------------------------------------------------------------
// ʕ
//-----------------------------------------------------------------------------
extern HFWD MemMgrMalloc( unsigned long );
extern void *MemMgrLock_GetPtr( HFWD );
//extern void MemMgrUnlock( HFWD );
//extern void MemMgrFree( HFWD );

//-----------------------------------------------------------------------------
// Typedef Definitions
//-----------------------------------------------------------------------------
typedef unsigned char  uchar;
typedef unsigned int   uint;
typedef unsigned long  ulong;

//#define  _NO_REQUEST           // check2! dl゠蓾Ȃ͂()
//#define  _NO_REQUEST2          // check2! fWG^ɂĂȂ͂
//#define  _NO_REQUEST3          // check2! OTSgc߂ł͔T|[g(APIŒe)

// eő吔
// PTX808IMP_MSA mod 2006.1.17 yamamoto 2000Ή if1
#define  OEMMPUTIL_MAX_DFALL_SONG         MUSIC_FILE_MAX
// PTX808IMP_MSA mod 2006.1.17 yamamoto 2000Ή endif
#define  OEMMPUTIL_MAX_MSNML_SONG         1000           // MS ttH_őyȐ
#define  OEMMPUTIL_MAX_MSPC_SONG          1000           // MS PCAgtH_őyȐ
#define  OEMMPUTIL_MAX_MSALL_SONG         (OEMMPUTIL_MAX_MSNML_SONG + OEMMPUTIL_MAX_MSPC_SONG)
#define  OEMMPUTIL_MAX_ALL_SONG           (OEMMPUTIL_MAX_DFALL_SONG + OEMMPUTIL_MAX_MSALL_SONG)
#define  OEMMPUTIL_MAX_DF_PLAYLIST        2000           // DF vCXgő吔
#define  OEMMPUTIL_MAX_MS_PLAYLIST        1000           // MS vCXgő吔
#define  OEMMPUTIL_MAX_ALL_PLAYLIST       (OEMMPUTIL_MAX_DF_PLAYLIST + OEMMPUTIL_MAX_MS_PLAYLIST)

// yȊǗf[^INDEX
#define  OEMMPUTIL_INDEX_DF_SONG          0                                                   // DF Jn
#define  OEMMPUTIL_INDEX_MSNML_SONG       OEMMPUTIL_MAX_DFALL_SONG                            // MS tJn
#define  OEMMPUTIL_INDEX_MSPC_SONG        (OEMMPUTIL_INDEX_MSNML_SONG+OEMMPUTIL_MAX_MSNML_SONG) // MS PCAgJn

// vCXgǗf[^INDEX
#define  OEMMPUTIL_INDEX_DF_PLAYLIST      0                                                   // DF vCXgJnINDEX
#define  OEMMPUTIL_INDEX_MS_PLAYLIST      OEMMPUTIL_MAX_DF_PLAYLIST                           // MS vCXgJnINDEX
#define  OEMMPUTIL_INDEX_LAST_PLAYLIST    OEMMPUTIL_MAX_ALL_PLAYLIST                          // vCXgŌINDEX

// ̑
#define  OEMMPUTIL_MAX_LABEL               21             // LABELސ 2021 TRK117
#define  OEMMPUTIL_MAX_JPN_LABEL           11             // {LABELސ
#define  OEMMPUTIL_MAX_ENG_LABEL           8             // pLABELސ PTX808 LabelSelect
#define  OEMMPUTIL_ALL_LABEL               OEMMPUTIL_MAX_JPN_LABEL+OEMMPUTIL_MAX_ENG_LABEL // {/pLABELv PTX808 LabelSelect
#define  OEMMPUTIL_NO_DLINKID              0xFFFFFFFF     // DlinkIDȂ(IMPǗt@C/yȊǗf[^gp)
#define  OEMMPUTIL_RSV_DLINKID             0xFFFFFFFE     // DlinkID\(IMPǗt@C/yȊǗf[^gp̈\)
#define  OEMMPUTIL_NO_DEVICENAME           0              // vCXgfoCXݒȂ(vCXgǗf[^gp)
#define  OEMMPUTIL_RSV_DEVICENAME          0xFFFFFFFF     // vCXgfoCX\(vCXgǗf[^gp̈\)
#define  OEMMPUTIL_DATAINIMPFILE           100            // 1IMPǗt@Cyȃf[^ő吔
#define  OEMMPUTIL_NO_INDEX                0xFFFF         // NSTOPPER/f[^Ȃ
#define  OEMMPUTIL_NO_IMPMNGNUM            9999           // IMPǗt@Cԍُl TRK1992
#define  OEMMPUTIL_MAX_ETC_LABEL           3              // LabelMngDatáhhxY PTX808 LabelSelect

#define  OEMMPUTIL_RATE_MIN                0
#define  OEMMPUTIL_RATE_MAX                5

#define  OEMMPUTIL_MAXFILENAME             256// checkTCY
#define  OEMMPUTIL_MAXSONGINPLAYLIST       30// 1005

#define  OEMMPUTIL_LIMIT_OK                (BYTE)0 // TRK1355
#define  OEMMPUTIL_LIMIT_NG                (BYTE)1 // TRK1355

//-----------------------------------------------------------------------------
// f[^
//-----------------------------------------------------------------------------
// i荞ݏ(̏ōi荞łP[X)
#define  OEMMPUTIL_SELECT_NOTHING      0x0000        // i荞݂Ȃ
#define  OEMMPUTIL_SELECT_SONGNAME     0x0001        // yȖōi荞
#define  OEMMPUTIL_SELECT_SONGLABEL    0x0002        // yȃxōi荞
#define  OEMMPUTIL_SELECT_ARTISTNAME   0x0004        // A[eBXgōi荞
#define  OEMMPUTIL_SELECT_ARTISTLABEL  0x0008        // A[eBXgxōi荞
#define  OEMMPUTIL_SELECT_ALBUMNAME    0x0010        // Aoōi荞
#define  OEMMPUTIL_SELECT_ALBUMLABEL   0x0020        // Aoxōi荞
#define  OEMMPUTIL_SELECT_TOP20        0x0040        // gbvQOōi荞
#define  OEMMPUTIL_SELECT_TOPRATE      0x0080        // gbv[gōi荞
#define  OEMMPUTIL_SELECT_TOPDATE      0x0100        // ŋߒȂōi荞
#define  OEMMPUTIL_SELECT_MMID         0x0200        // MMIDōi荞
// PTX808IMP_MSA add 2006.1.26 ooshima if1
#define  OEMMPUTIL_SELECT_MSA		   0x0400        // MSASȂōi荞
#define  OEMMPUTIL_SELECT_MSAGROUP	   0x0800        // MSAO[vōi荞
#define  OEMMPUTIL_SELECT_ALLDATA      0x1000        // MSA݂ōi荞
// PTX808IMP_MSA add 2006.1.26 ooshima endif

// xi荞ݏ
#define  OEMMPUTIL_LSELECT_NOTHING     0x0000        // Ȃ
#define  OEMMPUTIL_LSELECT_JPNSONG     0x0001        // {yȖ
#define  OEMMPUTIL_LSELECT_ENGSONG     0x0002        // pyȖ
#define  OEMMPUTIL_LSELECT_JPNARTIST   0x0010        // {A[eBXg
#define  OEMMPUTIL_LSELECT_ENGARTIST   0x0020        // pA[eBXg
#define  OEMMPUTIL_LSELECT_JPNALBUM    0x0100        // {Ao
#define  OEMMPUTIL_LSELECT_ENGALBUM    0x0200        // pAo

// i荞݊yȏ
typedef struct _S_SelectInfo {
        HFWD         SelectType;                         // i荞ݏ
        char         DeleteFlag;                         // CX^Xyȍ폜tO TRK2895
        char         reserve2;                           // 
        HFWD         reserve[6];                         // 
        char         MMID[IMP_MMID_LEN];                 // MMID
}S_SelectInfo;

// i荞݃Xg TRK1451Œǉ
typedef struct _S_SelectList {
        HFWD         SelectCount;                        // i荞݊yȐ
        HFWD         SelectCurrent;                      // Jgʒu
        HFWD         SelectList[OEMMPUTIL_MAX_ALL_SONG]; // i荞݊yȂ̊yȊǗf[^Index(擪SelectCount܂)
}S_SelectList;

// i荞݃e[u check9!
typedef struct _S_SelectTable {
        HFWD         Count;                              // i荞݊yȐ
        HFWD         SelectType;                         // i荞ݏ
        HFWD         LabelSelectType;                    // xi荞ݏ
        HFWD         Current;                            // Jgʒu(i荞ݐ擪̎Qƒ̊yȑΈʒu)FgpH
        HFWD         CurrentIndex;                       // JgʒuɂyȂ̊yȊǗf[^ւIndex
        HFWD         cMMIDSeek;                          // MMIDi荞ݐ 1005
        HFWD         CurrentMMIndex;                     //                1005
        HFWD         reserve;                            //                1005
        S_SelectInfo SelectInfo[OEMMPUTIL_MAX_ALL_SONG]; // i荞݊yȏ
        int          LanguageID;                         // GetLabelCounť 2005.09.03 matsumi suzuki
        HFWD         Top20[20] ;                         // gbvQOe[u TRK139 2005.10.03 
        HFWD         TopDate[20] ;                       // ŋߒȃe[u TRK139 2005.10.03 
        HFWD         MMIDSeek[OEMMPUTIL_MAXSONGINPLAYLIST] ;// MMIDi荞SEEK 1005
        S_SelectList SelectList;                         // i荞݃Xg TRK1451Œǉ
        // TRK2883 HFWD         PlayListSort[OEMMPUTIL_MAX_ALL_PLAYLIST] ; // TRK2057 2005/11/16 vCXgp\[ge[u 
        // PTX808IMP_MSA add 2006.1.12 ooshima if1
        HFWD         MSACount;                           // MSAi荞݊yȐ
        HFWD         MSACurrentIndex;                    // Jgʒu
        HFWD         MSAGroupNo;                         // MSAO[vԍ
        HFWD         MSAGroupCount;                      // MSAO[v
        //HFWD         MSASeekAllIndex;                    // KMF/MSA݃XgSeekʒu
        ulong         MSASeekAllIndex;                    // KMF/MSA݃XgSeekʒu
        // PTX808IMP_MSA add 2006.1.12 ooshima endif

// ȉAgcǉ
//    void        *pSelectData;    		     // i݊yȏ
//    uint16       nSelectCount;                       // i݊yȐ
//    void        *pSubData; 	   		     // ȋ݂
//    uint16       nSubCount;	                     // ȋ݂
//    boolean      bLabelFlag[12];   		     // xtO
//    char      ** pLabelStr;
//    void        *pCurrentData;                       // Jgf[^
}S_SelectTable;


// xf[^
typedef struct _S_LabelData {
        BYTE         size;                               // x
        char         label[7];                           // x
}S_LabelData;

//IMPǗ̏
typedef struct _NNameData {	
	char			Name[IMP_NAME_LEN]; 				/*  						*/
	char			Yomi[IMP_YOMI_LEN]; 				/*  ̓ǂ					*/
    char			 YomiNull[2];						 // ̓ǂNUL^[~l[g
    unsigned short	 reserve2;							 // 
    ulong			 YomiHash;							 // ̓ǂ32ȍ~ʎq
	unsigned short	NameSize; 							/*  ̃TCY					*/
	unsigned short	YomiSize; 							/*  ̓ǂ݃TCY				*/
	// TRK976 unsigned short	reserve[2];
	ulong           NameHash;                           // 64ȍ~ʎq
}ST_NIMP_NAME;

/* IMPǗ */
typedef struct _NIMPMngData {
	unsigned short	PlayCount;							/*  Đ					*/
	unsigned short	Rate;								/*  ڰď						*/
	unsigned int	LastPlayDate;						/*  ĐI				*/
	unsigned int	TruckNo;							/*  gbNNo.					*/
	DLINKNUM		DlinkID;							/*  DlinkID						*/
	char			MMID[IMP_MMID_LEN];					/*  MMID						*/
    ST_NIMP_NAME	Title;								/*  yȖ						*/
    ST_NIMP_NAME	Artist;								/*  A[eBXg				*/
    ST_NIMP_NAME	Album;								/*  Ao					*/
    unsigned long   FileTime;                           /*  t@Cۑ            */
    uchar           LimitCheck;                         /*  ĐL(0:/1:L)     */
    uchar           reserve1;
    uchar           reserve2;
    uchar           reserve3;
	int				reserve4[2];
} ST_NIMP_INFO;

//-----------------------------------------------------------------------------
// Ǘt@CEf[^XV
//-----------------------------------------------------------------------------
// IMPǗf[^ҏWpԔԍ
enum {
  OEMMPUTIL_ST_DFINIT = 0,          // ݒ蒆
  OEMMPUTIL_ST_DFCHECK1,            // DFf[^1
  OEMMPUTIL_ST_DFCHECK2,            // DFf[^2
  OEMMPUTIL_ST_DFUIMCHECK,          // DF UIM`FbN
  OEMMPUTIL_ST_MSINIT,              // MSǗf[^쐬
  OEMMPUTIL_ST_MSINITPLAYLIST,      // MSvCXg쐬
  OEMMPUTIL_ST_MSCHECK1,            // MSf[^`FbN1
  OEMMPUTIL_ST_MSCHECK2,            // MSf[^`FbN2
//  OEMMPUTIL_ST_MSFILEDELETE,        // IMPǗt@CXV 7/27폜
  OEMMPUTIL_ST_DATADELETE,          // f[^폜 10/04
  OEMMPUTIL_ST_IDLE                 // ACh
};

// ԊǗ
typedef struct _S_StatusInfo {
        int       StatusNumber;            // IMPǗf[^ҏŴ߂̏Ԕԍ
}S_StatusInfo;

// DFf[^`FbN
typedef struct _S_DFCheck {
        HFWD      CB_MemID;                // ppID
        DLINKNUM *pDlinkList;              // yȈꗗ|C^
        BYTE     *pDlinkChkList;           // yȈꗗ̊yȃf[^L`FbNXg|C^
        BYTE     *pMngDataChkList;         // yȊǗf[^̊yȗL`FbNXg|C^
        HFWD      MemID_DlinkList;         // yȈꗗID
        HFWD      MemID_DlinkChkList;      // yȈꗗ̊yȃf[^L`FbNXgID
        HFWD      MemID_MngDataChkList;    // yȊǗf[^̊yȗL`FbNXgID
        int       cCHAKUFULL;              // ttH_yȈꗗ
        int       cPCCOOP;                 // obAgtH_yȈꗗ
        HFWD      ListIndex;               // `FbNXg̎Ώ۔ԍ
}S_DFCheck;

// MSǗf[^쐬
typedef struct _S_MSInit {
        HFWD      CB_MemID;                // ppID
        HFWD      MngNo;                   // IMPǗt@Cԍ
}S_MSInit;

// MSf[^`FbN
typedef struct _S_MSCheck {
        HFWD      CB_MemID;                // ppID
        DLINKNUM *pFileList;               // yȈꗗ|C^
        BYTE     *pFileChkList;            // yȈꗗ̊yȃf[^L`FbNXg|C^
        BYTE     *pMngDataChkList;         // yȊǗf[^̊yȗL`FbNXg|C^
        HFWD      MemID_FileList;          // yȈꗗID
        HFWD      MemID_FileChkList;       // yȈꗗ̊yȃf[^L`FbNXgID
        HFWD      MemID_MngDataChkList;    // yȊǗf[^̊yȗL`FbNXgID
        int       cCHAKUFULL;              // ttH_yȈꗗ
        int       cPCCOOP;                 // obAgtH_yȈꗗ
        HFWD      ListIndex;               // `FbNXg̎Ώ۔ԍ
        HFWD      MemID_IMPFile;           // IMPǗt@CpID       TRK1992
        short     IMPChgFlg;               // IMPǗt@CXVۃtO   TRK1992
        short     IMPChgCnt;               // IMPǗt@CXVJEg     TRK1992
        ST_NIMP_INFO  *pIMPFile;           // IMPǗt@Cpf[^|C^ TRK1992
}S_MSCheck;

// yȒǉʒm
typedef struct _S_RepAddSong {
        HFWD   CB_MemID;                   // ppID
        int    Device_name;                // foCX
        int    Folder_name;                // tH_
        DLINKNUM  DlinkID;                 // DlinkIDorV[gt@C
        IMP_MusicInformation *pMusicDataInfo; // yȏ|C^
        HFWD   MusicDataInfo_MemID;        // yȏ񃁃ID
        HFWD   TIndex;                     // yȊǗf[^쐬ʒu(ŜINDEX)
        HFWD   FIndex;                     // yȊǗf[^쐬ʒu(tH_INDEX)
}S_RepAddSong;

// yȍ폜ʒm
typedef struct _S_RepDelSong {
        HFWD   CB_MemID;                   // ppID
        int    Device_name;                // foCX
        int    Folder_name;                // tH_
        HFWD   FIndex;                     // yȊǗf[^폜ʒu(tH_INDEX)
}S_RepDelSong;

// yȍ폜
typedef struct _S_DelSong {
        HFWD    CB_MemID;                  // ppID
        void   *pCB;                       // R[obNCxgʒm̃f[^|C^
        int     Device_name;               // foCX
        int     Folder_name;               // tH_
        int     Mng_number;                // IMPǗt@Cԍ
        int     Music_number;              // IMPǗt@CyȈʒu(ԍ)
        HFWD    TIndex;                    // yȊǗf[^폜ʒu(ŜINDEX)
        HFWD    FIndex;                    // yȊǗf[^폜ʒu(tH_INDEX)
        S_SelectTable *pSelectTable;       // i荞݃e[u|C^
        //PTX808 ST_MSA_DIR_INFOGAMalloc 2006.2.9 toida if1
        HFWD    TrackInfoID;               // ppID
        ST_MSA_DIR_INFO *pTrackInfo;       // ppID(DATA)
        //PTX808 ST_MSA_DIR_INFOGAMalloc endif
}S_DelSong;

// vCXgXV
typedef struct _ChgPlayList {
        HFWD      CB_MemID;                // ppID
        HFWD      DATA_MemID;              // ppID(DATA)
        void     *pCB;                     // R[obNCxgʒm̃f[^|C^
        int       Device_name;             // foCX
        DLINKNUM  DlinkID;                 // DlinkIDorV[gt@C
        char     *pData;                   // vCXgf[^GA|C^
        uint32    dwDataSize;              // vCXgf[^TCY
        HFWD      Name_MemID;              // VvCXgt@CpID 1021 TRK725
        char     *pFileName;               // VvCXgt@C           1021 TRK725
}S_ChgPlayList;

// vCXgo^
typedef struct _AddPlayList {
        HFWD      CB_MemID;                // ppID
        HFWD      DATA_MemID;              // ppID(DATA)
        void     *pCB;                     // R[obNCxgʒm̃f[^|C^
        int       Device_name;             // foCX
        char     *pData;                   // vCXgf[^GA|C^
        uint32    dwDataSize;              // vCXgf[^TCY
        char      szFileName[AEE_MPUTIL_FILENAME_SIZE_MAX +1];// vCXgt@C
        HFWD      PLIndex;                 // vCXgǗf[^̓o^Index
}S_AddPlayList;

// yȏXV
typedef struct _UpdateSong {
        HFWD      CB_MemID;                // ppID
        void     *pCB;                     // R[obNCxgʒm̃f[^|C^
        HFWD      TIndex;                  // yȊǗf[^XVʒu(ŜINDEX)
        int       nParmID;                 // XV(Đ/[g)
        int       Value;                   // XVl
}S_UpdateSong;

// yȏڍ׏擾
typedef struct _GetInfoData {
        HFWD               CB_MemID;       // ppID
        HFWD               DATA_MemID;     // ppID(DATA)
        void              *pCB;            // R[obNCxgʒm̃f[^|C^
        HFWD               TIndex;         // yȊǗf[^XVʒu(ŜINDEX)
        HFWD               FIndex;         // yȊǗf[^폜ʒu(tH_INDEX)
        int                Device_name;    // foCX
        int                Folder_name;    // tH_
        DLINKNUM           DlinkID;        // DlinkIDorV[gt@C
        AEEMPUtilDataInfo *pDataInfo;      // yȏڍ׏GA|C^
        IMP_MusicInformation *pMusicInfo;  // yȑSڍ׏GA|C^
        HFWD               MusicInfo_MemID;// yȑSڍ׏GAID
        // PTX808IMP_MSA add 2006.1.12 ooshima if1
        S_SelectTable     *SelectTable;	   // ZNge[u
        HFWD              TrackInfoID;     // ppID
        ST_MSA_TRACK_INFO *pTrackInfo;     // ppID(DATA)
        // PTX808IMP_MSA add 2006.1.12 ooshima endif
        // PTX808 WPʃTCYKΏ 2006/2/20 if1
        char              *pImage;         // C[Wf[^ǂݍ݃GA|C^
        HFWD              Image_MemID;    // C[Wf[^ǂݍ݃GAID
        // PTX808 WPʃTCYKΏ 2006/2/20 endif
}S_GetInfoData;

// TRK2085 Î~摜f[^擾
typedef struct _S_GetImage{
  ulong    ImageSize;         // 摜TCY
  char    *pImage;            // 摜f[^|C^
  HFWD     I_MemID;           // 摜f[^MemID
  HFWD     reserve[3];        // U[ü
} S_GetImage;
// TRK2085

// Î~摜擾
typedef struct _GetImageData {
        HFWD                CB_MemID;      // ppID
        HFWD                DATA_MemID;    // ppID(DATA)
        void               *pCB;           // R[obNCxgʒm̃f[^|C^
        int                 Device_name;   // foCX
        int                 Folder_name;   // tH_
        DLINKNUM            DlinkID;       // DlinkIDorV[gt@C
        AEEMPUtilImageInfo *pImageInfo;    // yȃf[^̊eÎ~GA|C^
        char               *pImageDataName;// Î~t@Co̓GA|C^
//TRK805        char               *pImage;        // C[Wf[^ǂݍ݃GA|C^
        S_GetImage         *pImage;        // C[Wf[^ǂݍ݃GA|C^ TRK2085
        HFWD                Image_MemID;   // C[Wf[^ǂݍ݃GAID
//TRK805        ulong               ImageSize;     // C[Wf[^TCY {
        // PTX808IMP_MSA add 2006.1.12 ooshima if1
        HFWD                TIndex;        // yȊǗf[^XVʒu(ŜINDEX)
        S_SelectTable       *SelectTable;  // ZNge[u
        // PTX808IMP_MSA add 2006.1.12 ooshima endif
}S_GetImageData;

// PTX808IMP_MSA mod 2006.1.17 yamamoto ̎J[hێ if1
typedef struct _GetWordsData{
	char *pWordsName;	// Î~t@Co̓GA|C^
	HFWD Name_MemID;	// Î~t@Co̓GAID
	S_GetImage *pWordsData;	// C[Wf[^ǂݍ݃GA|C^
	HFWD Data_MemID;	// C[Wf[^ǂݍ݃GAID
}S_GetWordsData;
// PTX808IMP_MSA mod 2006.1.17 yamamoto ̎J[hێ endif

// yȈړʒm
typedef struct _RepMoveSonga {
        HFWD                CB_MemID;      // ppID
        void               *pCB;           // R[obNCxgʒm̃f[^|C^
        int                 SrcDevice_name;// ړOfoCX
        int                 SrcFolder_name;// ړOtH_
        HFWD                SrcFIndex;     // ړOyȊǗf[^ʒu(tH_INDEX)
        HFWD                SrcTIndex;     // ړOyȊǗf[^ʒu(ŜINDEX)
        int                 DstDevice_name;// ړOfoCX
        int                 DstFolder_name;// ړtH_
        HFWD                DstFIndex;     // ړyȊǗf[^ʒu(tH_INDEX)
        HFWD                DstTIndex;     // ړyȊǗf[^ʒu(ŜINDEX)
        DLINKNUM            DstDlinkID;    // ړDlinkIDorV[gt@C
}S_RepMoveSong;


//-----------------------------------------------------------------------------
// Ǘf[^
//-----------------------------------------------------------------------------

// ̃f[^
typedef struct _S_NameData {
        char         Name[IMP_NAME_LEN];                 // 
        char         Yomi[IMP_YOMI_LEN];                 // ̓ǂ
        char         YomiNull[2];                        // ̓ǂNUL^[~l[g
        HFWD         reserve;                            // 
        ulong        YomiHash;                           // ̓ǂ32ȍ~ʎq
        HFWD         NameSize;                           // ̃TCY
        HFWD         YomiSize;                           // ̓ǂ݃TCY
	    ulong        NameHash;                           // 64ȍ~ʎq TRK976
}S_NameData;

// yȊǗf[^
typedef struct _S_SongMngData {
//        HFWD         Index;                              // INDEX(zʒu)
        HFWD         PlayCount;                          // Đ
        HFWD         Rate;                               // [g
//        HFWD         Reserve;

        uint         LastPlayDate;                       // ĐŏI
        unsigned long FileTime;                          // t@Cۑ
        uchar        TrackNum;                           // gbNNo.
        uchar        AllTrackCount;                      // SgbN
        HFWD         reserve2;
        DLINKNUM     DlinkID;                            // DlinkID/yȃt@Cԍ
        char         MMID[IMP_MMID_LEN];                 // MMID

        S_NameData   Title;                              // yȖ
        S_NameData   Artist;                             // A[eBXg
        S_NameData   Album;                              // Ao

        HFWD         AllTitleFWIdx;                      // SyȖ̓ǂ݂ɂ鏇NIndex
        HFWD         AllTitleRVIdx;                      // SyȖ̓ǂ݂ɂtNIndex
        HFWD         AllArtistFWIdx;                     // SA[eBXg̓ǂ݂ɂ鏇NIndex
        HFWD         AllArtistRVIdx;                     // SA[eBXg̓ǂ݂ɂtNIndex
        HFWD         AllAlbumFWIdx;                      // SAo̓ǂ݂ɂ鏇NIndex
        HFWD         AllAlbumRVIdx;                      // SAo̓ǂ݂ɂtNIndex
        HFWD         ArtistTitleFWIdx;                   // 0922 A[eBXg̊yȖ̓ǂ݂ɂ鏇NIndex
        HFWD         ArtistTitleRVIdx;                   // 0922 A[eBXg̊yȖ̓ǂ݂ɂtNIndex
//0922        HFWD         ArtistTitleDateFWIdx;               // A[eBXg̃t@Cۑɂ鏇NIndex
//0922        HFWD         ArtistTitleDateRVIdx;               // A[eBXg̃t@CۑɂtNIndex
        HFWD         ArtistAlbumFWIdx;                   // A[eBXg̃Ao̓ǂ݂ɂ鏇NIndex
        HFWD         ArtistAlbumRVIdx;                   // A[eBXg̃Ao̓ǂ݂ɂtNIndex
        HFWD         AlbumFWIdx;                         // AõgbNԍɂ鏇NIndex
        HFWD         AlbumRVIdx;                         // AõgbNԍɂtNIndex
        HFWD         AllDateFWIdx;                       // SyȂ̃t@Cۑɂ鏇NIndex
        HFWD         AllDateRVIdx;                       // SyȂ̃t@CۑɂtNIndex

        BYTE         UIMCheck;                           // UIM`FbN
        BYTE         LimitCheck;                         // ĐL(0:/1:L)

        DLINKNUM     RSVDlinkID;                         // 805TRK2070 \DlinkID@OEMMPUTIL_RSV_DLINKID(\)̂ݗL
        BYTE         reserve[2];
}S_SongMngData;

// yȊǗNf[^
typedef struct _S_SongMngData_L {
        HFWD           CountDF;                          // DFyȐ
        HFWD           CountMSUta;                       // MStyȐ
        HFWD           CountMSPC;                        // MS PCAgyȐ
        HFWD           reserve[5];                       // 
                                                         // yȊǗf[^ւ̃|C^
        S_SongMngData *pSongMngData[OEMMPUTIL_MAX_ALL_SONG];
        HFWD           DFMemID;                          // DFyȊǗf[^GAID
        HFWD           reserve2;                         // 
        HFWD           MSUtaMemID[10];                   // MStyȊǗf[^GAID
        HFWD           MSPCMemID[10];                    // MSPCAgyȊǗf[^GAID
        HFWD           reserve3[2];                      // 
}S_SongMngData_L;

// vCXgf[^
typedef struct _S_PlayListData {
        int          Device_name;                        // foCX(DForMS)
        int          reserve;
        DLINKNUM     DlinkID;                            // DlinkID/zԍ
		ulong        FileTime;
}S_PlayListData;

// vCXgǗNf[^
typedef struct _S_PlayListMngData {
//TRK1330        HFWD           Count;                                   // vCXgyȐ
        HFWD           DFCount;                                 // DFvCXgyȐ
        HFWD           MSCount;                                 // MSvCXgyȐ
//TRK1330        HFWD           reserve[7];                              // 
        HFWD           reserve[6];                              // U[ü
        S_PlayListData PlayListData[OEMMPUTIL_MAX_ALL_PLAYLIST];// vCXgf[^
}S_PlayListMngData;

/* vCXg\[gf[^ */// TRK2883
typedef struct _S_PlayListSort {
        HFWD         Count;
        HFWD         PlayListSort[OEMMPUTIL_MAX_ALL_PLAYLIST] ;
}S_PlayListSort;

// xǗNf[^
typedef struct _S_LabelMngData {
        HFWD TitleHdIndex[OEMMPUTIL_MAX_LABEL];     // SyȂ̊ex擪̊yȊǗf[^Index
        HFWD TitleTlIndex[OEMMPUTIL_MAX_LABEL];     // SyȂ̊exŏI̊yȊǗf[^Index
        HFWD ArtistNameHdIndex[OEMMPUTIL_MAX_LABEL];// SA[eBXg̊ex擪̊yȊǗf[^Index
        HFWD ArtistNameTlIndex[OEMMPUTIL_MAX_LABEL];// SA[eBXg̊exŏI̊yȊǗf[^Index
        HFWD AlbumNameHdIndex[OEMMPUTIL_MAX_LABEL]; // SAo̊ex擪̊yȊǗf[^Index
        HFWD AlbumNameTlIndex[OEMMPUTIL_MAX_LABEL]; // SAo̊exŏI̊yȊǗf[^Index
}S_LabelMngData;

// y/vCXgꗗ
typedef struct _S_SongList {
        HFWD      FIndex;                             // yorvCXgǗf[^Index
        DLINKNUM  DlinkID;                            // yorvCXgt@CDlinkID
}S_SongList;

/*======================================================*/
#define __0915__
#define __0916__

#define OEMMPUTIL_K_ADDSONG  1
#define OEMMPUTIL_K_DELSONG  2
#define OEMMPUTIL_K_MOVESONG 3
#define OEMMPUTIL_K_RENEW    4
#define OEMMPUTIL_K_NOACTION 9 // 805TRK2070 UpDate

//#ifdef __0915__
typedef struct _S_FDCOM {
        void  *pNext;
        HFWD   CB_MemID;                   // ppID
        HFWD   kind;
}S_FDCOM;
//TRK2253 typedef struct _S_OEMMPUTIL_FD_QUE {
//TRK2253         S_FDCOM   *hp;
//TRK2253         S_FDCOM   *tp;
//TRK2253 }S_OEMMPUTIL_FD_QUE;

typedef struct _S_NRepAddSong {
        S_FDCOM   FDcom;
        int       Device_name;                // foCX
        int       Folder_name;                // tH_
        DLINKNUM  DlinkID;                    // DlinkIDorV[gt@C
        HFWD      TIndex;                     // yȊǗf[^쐬ʒu(ŜINDEX)
        HFWD      FIndex;                     // yȊǗf[^쐬ʒu(tH_INDEX)
}S_NRepAddSong;

typedef struct _S_NRepDelSong {
        S_FDCOM FDcom;
        int     Device_name;               // foCX
        int     Folder_name;               // tH_
        int     Mng_number;                // IMPǗt@Cԍ
        int     Music_number;              // IMPǗt@CyȈʒu(ԍ)
        HFWD    TIndex;                    // yȊǗf[^폜ʒu(ŜINDEX)
        HFWD    FIndex;                    // yȊǗf[^폜ʒu(tH_INDEX)
        S_SelectTable *pSelectTable;       // i荞݃e[u|C^
}S_NRepDelSong;

typedef struct _S_NRepMoveSong {
        S_FDCOM   FDcom;
        int       SrcDevice_name;// ړOfoCX
        int       SrcFolder_name;// ړOtH_
        HFWD      SrcFIndex;     // ړOyȊǗf[^ʒu(tH_INDEX)
        HFWD      SrcTIndex;     // ړOyȊǗf[^ʒu(ŜINDEX)
        int       DstDevice_name;// ړOfoCX
        int       DstFolder_name;// ړtH_
        HFWD      DstFIndex;     // ړyȊǗf[^ʒu(tH_INDEX)
        HFWD      DstTIndex;     // ړyȊǗf[^ʒu(ŜINDEX)
        DLINKNUM  DstDlinkID;    // ړDlinkIDorV[gt@C
}S_NRepMoveSong;

typedef struct _S_ReNew {
        S_FDCOM   FDcom;
        int       Device_name;                // foCX
        int       Folder_name;                // tH_
        DLINKNUM  DlinkID;                    // DlinkIDorV[gt@C
        HFWD      FIndex;                     // yȊǗf[^쐬ʒu(tH_INDEX)
        HFWD      TIndex;// TRK1355           // yȊǗf[^쐬ʒu(ŜINDEX)
}S_ReNew;

//TRK2253
typedef union _U_FD_QUEDATA{
        S_NRepAddSong  U_AData;
        S_NRepDelSong  U_DData;
        S_NRepMoveSong U_MData;
        S_ReNew        U_RData;
}U_FD_QUEDATA;

typedef struct _S_OEMMPUTIL_FD_QUE {
        U_FD_QUEDATA   *hp;
        U_FD_QUEDATA   *tp;
        HFWD      CB_MemID;               // ppID
}S_OEMMPUTIL_FD_QUE;
//TRK2253

//#endif

/*======================================================*/


// ȍ~Agc쐬
/*======================================================
FILE:  OEMMPUtilCB.h

SERVICES:
   OEM functions for supporting BREW MPUTIL
   Interface

GENERAL DESCRIPTION:
   This file provides the prorotypes of the functions
   that OEMs must provide in order to support the BREW
   MPUTIL interfaces

=====================================================*/
//#include "AEE.h"

// R[obNCxg
enum {
    MPUTIL_CB_DEFAULT = 0,		// CBCxg̑(`)
    MPUTIL_CB_DF_CONSISTENCY_CHECK,	// DFf[^`FbN
    MPUTIL_CB_UIM_CONSISTENCY_CHECK,	// UIM`FbN
    MPUTIL_CB_MS_CONTROL_DATA_CREATE,	// MSǗf[^쐬
    MPUTIL_CB_MS_PLAYLIST_DATA_CREATE,	// MSvCXgf[^쐬
    MPUTIL_CB_MS_CONSISTENCY_CHECK,	// MSf[^`FbN
    MPUTIL_CB_MS_CONTROL_FILE_UPDATE,	// IMPǗt@CXV
    MPUTIL_CB_ADD_KMF,			// yȒǉ
    MPUTIL_CB_DELETE_KMF,		// yȍ폜
    MPUTIL_CB_ADD_KPL,			// vCXgǉ
    MPUTIL_CB_DELETE_KPL,		// vCXg폜
    MPUTIL_CB_MS_INSERT,		// MS}
    MPUTIL_CB_MS_EXTRACT,		// MS
    MPUTIL_CB_NATIVE,			// Native DF
    MPUTIL_CB_DECODE,                   // 摜ŃR[h
// UIQ119[S] MMID}b`O
    MPUTIL_CB_MATCH_MMID                // MMID}b`O
// UIQ119[S] MMID}b`O
};

typedef void (*MPUTILCBFUNC) ( int eCbType, void * pUserData );
typedef void (*MPUTILMSCBFUNC) ( int eCbType, void * pUserData, void *pUpData );

// R[obN
extern void MPUTIL_I_CBInit();
// R[obNݒ
extern int  MPUTIL_I_CBSet( MPUTILCBFUNC CbFunc, int eCbType, void * pData, boolean bIsMemoryFree );
extern int  MPUTIL_I_MSCBSet( MPUTILMSCBFUNC CbFunc, int eCbType, void * pData, boolean bIsMemoryFree, void * pCBData );//0922
#endif // _OEMMPUTILDATACTRL_H_
