/*******************************************************************************
*                              Openwave Systems.                               *
*                            Device Products Group                             *
*                               Shinjuku, Tokyo                                *
****************************************************************************//**
   @file
   ̃wb_[t@CDEVICE:  FILE: ŎwKDDIgT[rX
   IɊǗ邽߂OEM񋟂C^[tF[X`Ă܂B
   OEM͂̃wb_[t@CύX邱Ƃ͂ł܂B

*//*
   REVISION HISTORY:
   Date:       Who:               Email:
      - Details:
--------------------------------------------------------------------------------
   15 Nov 2004 kawa               yoshihiro.kawaguchi@openwave.com
      - Initial version

*******************************************************************************/
/*******************************************************************************
*                  Copyright (c) Openwave Systems 1995-2004                    *
*                            All rights reserved.                              *
*                                                                              *
*     THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Openwave Systems Inc.     *
*               The copyright notice above does not evidence any               *
*              actual or intended publication of such source code.             *
*******************************************************************************/

#ifndef _IOMBDEV_H
#define _IOMBDEV_H


/*==============================================================================

	INCLUDES

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't include these if we're only preprocessing & not compiling
#include "aee.h"	// for size_t, etc
#include "aeestdlib.h"	// for size_t, etc
#include "aeeinterface.h"
#endif //ndef PREPROCESSING_ONLY


/*==============================================================================

	DEFINES

==============================================================================*/


/*==============================================================================

	TYPES

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't include these if we're only preprocessing & not compiling

/** @ingroup grp_internalservice
 IOMBDEV_InternalServiceԂN^Cv̒`
*/
typedef enum {
	keAPP_STANDALONE,		///< AvJڂȂ, uEU[gŏB
	keAPP_NORMAL,			///< AvJځiʏNj, uEU瑼AvɑJڂB
	keAPP_CHAINEND,			///< AvJځiʏN{AIj, uEU瑼AvɑJڂB
	keAPP_REFERENCE,		///< AvJځiQƋNj, uEU[瑼̃AvɑJڂBJڌAvtqk𐶐uEU[ɖ߂B
	keAPP_BACKGROUND		///< obNOhAvN, uEU[ɃobNOhAvNB
} teOMBDEVServiceTypes;

/** @ingroup grp_internalservice
 IOMBDEV_InternalServicBackground()œo^R[obN֐̒`
@PARAMETERS
 @param[in] pvUser IOMBDEV_InternalServiceBackground()ňnꂽCӂUser datã|C^B
 @param[in] iStatus Iʒm̃Xe[^XR[hA0:I 0ȊOFG[IiɋKȂjB
 @param[in] pvReqparam BrowserNp[^ւ̃|C^łAOEMKCPTYPE_APPCOMMBASE{
 uEU\v\iSTR_BROWSER_SETjnBN̕KvȂꍇNULLݒ肷B
 @param[in] iReqparamsize  BrowserNp[^ pvReqparam ̃oCgBN̕KvȂꍇ
 0ݒ肷B
@RETURNS
 @retval TRUE I
 @retval FALSE G[IiʂȃG[͕svj

*/
typedef boolean (*tpfoNotifyResult)(  void *pvUser, int iStatus, void *pvReqparam, int iReqparamsize );

/** @ingroup grp_download_anything
 IOMBDEV_DLValidateContextԂXe[^X̒`
*/
typedef enum {
	keDLVC_Accept,				///< Ώۃf[^͎M\łB
	keDLVC_InvalidFileType,		///< Ώۃf[^͖ΉłB
	keDLVC_InvalidFileSize,		///< Ώۃf[^̓TCYI[o[łB
} teOMBDEVDLValidateStatus;

/** @ingroup grp_plugin
 IOMBDEV_PluginRedrawSequenceԂXe[^X̒`
*/
typedef enum {
	kePluginRS_NoRedraw,		///< ʂȍĕ`揈͍sȂB
	kePluginRS_RedrawByUrlMoveWhenStopped, ///< ~ۂɌ݂URLωĂꍇ͍ĕ`悷B
	kePluginRS_Reserved 		///< \lBgpsB
} teOMBDEVPluginRedrawSequence;


#endif //ndef PREPROCESSING_ONLY

/*==============================================================================

	INTERFACE

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't define if we're only pre-processing to expand the macros

/** @ingroup grp_lifecycle
 IOMBDEVNX̃CX^X\`B NXID @ref AEECLSID_IOMBDEV 
 ISHELL_CreateInstanceɂCX^XꍇɕԂB
 @code
 #include iombdev.bid
 #include iombdev.h

 tsIOMBDEV *psIOMBDEV = NULL;
 if((SUCCESS == ISHELL_CreateInstance(psShell, AEECLSID_IOMBDEV, (void**)&psIOMBDEV)) && psIOMBDEV)
 {


   // release the interface when finisheed
   IOMBV6_Release(psIOMBVDEV);
   psIOMBDEV = NULL;
 }
@endcode

*/
typedef struct stIOMBDEV tsIOMBDEV;

#ifndef DOXYGEN_SHOULD_SKIP_THIS //make doxygen ignore this block of code
///z֐e[u̒`
AEEINTERFACE( IOMBDEV )
{
   //declare our virtual functions using macro expansion
   #define FUNCTION( RETURNS, NAME )   RETURNS (*NAME)(
   #define NO_PARAM                    void
   #define FIRST_PARAM( TYPE, NAME )   TYPE NAME
   #define NEXT_PARAM( TYPE, NAME )    , TYPE NAME
   #define END_FUNCTION                );
   #include "iombdev.m"
};
#endif //ndef DOXYGEN_SHOULD_SKIP_THIS

#endif //ndef PREPROCESSING_ONLY

/*==============================================================================

	VIRTUAL FUNCTION ACCESSORS

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't define if we're only pre-processing to expand the macros

/** @ingroup grp_lifecycle
 @ref AddRef ֐̃bp[`B ̃}N͂̊֐̃Avbǧďo
 eՂɂB
*/
#define IOMBDEV_AddRef( psIOMBDEV ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->lwIOMBDEV_AddRef( psIOMBDEV )

/** @ingroup grp_lifecycle
 @ref Release ֐̃bp[`B ̃}N͂̊֐̃Avbǧďo
 eՂɂB
*/
#define IOMBDEV_Release( psIOMBDEV ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->lwIOMBDEV_Release( psIOMBDEV )

/** @ingroup grp_internalservice
 @ref InternalService ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_InternalService( psIOMBDEV, kcpURL, kpcCallingUrl, pcSchema, piSchemalen, pvReqparam, piReqparamsize, peTypes ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->InternalService( psIOMBDEV, kcpURL, kpcCallingUrl, pcSchema, piSchemalen, pvReqparam, piReqparamsize, peTypes )

/** @ingroup grp_internalservice
 @ref InternalServiceGetURL ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_InternalServiceGetURL( psIOMBDEV, kpcRequesturl, pvReference, pvReqparam, piReqparamsize ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->InternalServiceGetURL( psIOMBDEV, kpcRequesturl, pvReference, pvReqparam, piReqparamsize )

/** @ingroup grp_internalservice
 @ref InternalServiceRelease ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_InternalServiceRelease( psIOMBDEV, pvReqparam ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->InternalServiceRelease( psIOMBDEV, pvReqparam )

/** @ingroup grp_internalservice
 @ref InternalServiceBackground ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_InternalServiceBackground( psIOMBDEV, pvBgparam, pfoNotifyResult, pvUser ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->InternalServiceBackground( psIOMBDEV, pvBgparam, pfoNotifyResult, pvUser )

/** @ingroup grp_internalservice
 @ref CancelBackground ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_CancelBackground( psIOMBDEV ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->CancelBackground( psIOMBDEV )

/** @ingroup grp_internalservicefile
 @ref InternalServiceFile ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_InternalServiceFile( psIOMBDEV, kpcUrl, kppcContentType, pcBuf, pwBuflen, kpcCallingUrl ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->InternalServiceFile( psIOMBDEV, kpcUrl, kppcContentType, pcBuf, pwBuflen, kpcCallingUrl )

/** @ingroup grp_download_anything
 @ref eDLValidateContext ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_DLValidateContext( psIOMBDEV, kpszFileName, kpszFileType, dwFileSize ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->eDLValidateContext( kpszFileName, kpszFileType, dwFileSize )

/** @ingroup grp_download_anything
 @ref kpczDLAcceptContext ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_DLAcceptContext( psIOMBDEV, kpszFileType, dwFileSize ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->kpczDLAcceptContext( kpszFileType, dwFileSize )

/** @ingroup grp_saveas
 @ref oSaveAsValidateData ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_SaveAsValidateData( psIOMBDEV, pvBuffer, dwSize, kpczExt ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->oSaveAsValidateData( pvBuffer, dwSize, kpczExt )

/** @ingroup grp_plugin
 @ref ePluginRedrawSequence ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBDEV_PluginRedrawSequence( psIOMBDEV, lwClsID ) \
	AEEGETPVTBL( (psIOMBDEV), IOMBDEV )->ePluginRedrawSequence( lwClsID )

#endif //ndef PREPROCESSING_ONLY

/*==============================================================================

	GLOBAL VARIABLE DECLARATIONS

==============================================================================*/


/*==============================================================================

	FUNCTION DECLARATIONS

==============================================================================*/


#endif /* _IOMBDEV_H */



