/*******************************************************************************
*                              Openwave Systems.                               *
*                            Device Products Group                             *
*                               Shinjuku, Tokyo                                *
****************************************************************************//**
   @file
   ̃wb_[t@C̓[UɂăNCAgؖIKvɉ
   PIN͂UI𓝈IɊǗ邽߂OEM񋟂C^[tF[X
   `Ă܂BOEM͂̃wb_[t@CύX邱Ƃ͂ł܂B

*//*
   REVISION HISTORY:
   Date:       Who:               Email:
      - Details:
--------------------------------------------------------------------------------
   23 Aug 2005 kawa               yoshihiro.kawaguchi@openwave.com
      - Initial version

*******************************************************************************/
/*******************************************************************************
*                  Copyright (c) Openwave Systems 1995-2005                    *
*                            All rights reserved.                              *
*                                                                              *
*     THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Openwave Systems Inc.     *
*               The copyright notice above does not evidence any               *
*              actual or intended publication of such source code.             *
*******************************************************************************/

#ifndef _IOMBSEC_H
#define _IOMBSEC_H


/*==============================================================================

	INCLUDES

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't include these if we're only preprocessing & not compiling
#include "aee.h"	// for size_t, etc
#include "aeestdlib.h"	// for size_t, etc
#include "aeeinterface.h"
#include "aeersa.h"
#endif //ndef PREPROCESSING_ONLY


/*==============================================================================

	DEFINES

==============================================================================*/


/*==============================================================================

	TYPES

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't include these if we're only preprocessing & not compiling

/** @ingroup grp_client_certification
 IOMBSEC_GetClientCertAndKeyUI()œo^R[obN֐ɕԂR[obNʂ̒`
*/
typedef enum {
	keIOMBSEC_CB_OK,			///< OK, I
	keIOMBSEC_CB_REJECT,		///< ؖo
	keIOMBSEC_CB_NOTEXIST,		///< ؖȂ
	keIOMBSEC_CB_EXPIRE,		///< ؖL؂
	keIOMBSEC_CB_PINFAIL,		///< PIN̓G[
	keIOMBSEC_CB_INTERNAL		///< ̑AC^[iG[
} teIOMBSEC_CB_Result;

/** @ingroup grp_client_certification
 IOMBSEC_GetClientCertAndKeyUI() œo^R[obN֐̒`
 ̃R[obN֐̓NCAgؖUI̊ʒmƂWIMɊi[Ă
 NCAgؖAԏؖє閧iIvVjuEUɈn܂B
@PARAMETERS
 @param[in] pvUser IOMBSEC_GetClientCertAndKeyUI() œnꂽCӂUser datã|C^
 @param[in] psIRSA IRSAIuWFNgւ̃|C^BIOMBSECŏpIRSACX^X
 iIRSA_initjĂBIRSAIuWFNgOEMIRSAC^[tF[X
 pĎOEMRSAłAuEU͂IRSACX^XʂWIMEncrypt@\
 gp܂BuEU͈nꂽ psIRSA AddRef܂B
 @param[in] pbClientCert DERGR[hꂽNCAgؖւ̃|C^
 @param[in] lClientCertLen  NCAgؖ̃oCgTCY
 @param[in] pbIntermediateCert DERGR[hꂽNCAgؖɃ`F[
 ԏؖ ւ̃|C^Bԏ݂ؖȂꍇNULLZbgĂB
 @param[in] lIntermediateCertLen  ԏؖ̃oCgTCY
 @param[in] pbPrivateKey  DERGR[hꂽ閧ւ̃|C^(IvVjB@ł
 WIM閧oƂ͋ĂȂNULLݒ肵ĂBNULLݒ肳ꂽ
 ꍇuEU͏ psIRSA ʂOEMRSAŒ񋟂WIMEncrypt@\𗘗p܂B
 閧ݒ肳ꂽꍇOpenSSLRSA_sign@\ɂ菐s܂iؗpjB閧
 NCAgؖ̌JƃyAł邱ƂKvłB
 @param[in] lPrivateKeyLen  閧̃oCgTCYiIvVj
 @param[in] eResult R[obNʁB 펞͂OAُiLZj͂OȊOZbgB
@RETURNS
 @retval TRUE I 
 @retval FALSE G[IiʂȃG[͕svj  
*/
typedef void (*PFNCLIENTCERTANDKEY)(void *pvUser, IRSA *psIRSA, 
								byte *pbClientCert, int lClientCertLen,  
								byte *pbIntermediateCert, int lIntermediateCertLen, 
								byte *pbPrivateKey, int lPrivateKeyLen, 
								teIOMBSEC_CB_Result eResult);

#endif //ndef PREPROCESSING_ONLY

/*==============================================================================

	INTERFACE

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't define if we're only pre-processing to expand the macros

/** @ingroup grp_lifecycle
 IOMBSECNX̃CX^X\`B NXID @ref AEECLSID_IOMBSEC 
 ISHELL_CreateInstanceɂCX^XꍇɕԂB
 @code
 #include iombsec.bid
 #include iombsec.h

 tsIOMBSEC *psIOMBSEC = NULL;
 if((SUCCESS == ISHELL_CreateInstance(psShell, AEECLSID_IOMBSEC, (void**)&psIOMBSEC)) && psIOMBSEC)
 {


   // release the interface when finished
   IOMBV6_Release(psIOMBSEC);
   psIOMBSEC = NULL;
 }
@endcode

*/
typedef struct stIOMBSEC tsIOMBSEC;

#ifndef DOXYGEN_SHOULD_SKIP_THIS //make doxygen ignore this block of code
///z֐e[u̒`
AEEINTERFACE( IOMBSEC )
{
   //declare our virtual functions using macro expansion
   #define FUNCTION( RETURNS, NAME )   RETURNS (*NAME)(
   #define NO_PARAM                    void
   #define FIRST_PARAM( TYPE, NAME )   TYPE NAME
   #define NEXT_PARAM( TYPE, NAME )    , TYPE NAME
   #define END_FUNCTION                );
   #include "iombsec.m"
};
#endif //ndef DOXYGEN_SHOULD_SKIP_THIS

#endif //ndef PREPROCESSING_ONLY

/*==============================================================================

	VIRTUAL FUNCTION ACCESSORS

==============================================================================*/
#ifndef PREPROCESSING_ONLY //don't define if we're only pre-processing to expand the macros

/** @ingroup grp_lifecycle
 @ref AddRef ֐̃bp[`B ̃}N͂̊֐̃Avbǧďo
 eՂɂB
*/
#define IOMBSEC_AddRef( psIOMBSEC ) \
	AEEGETPVTBL( (psIOMBSEC), IOMBSEC )->lwIOMBSEC_AddRef( psIOMBSEC )

/** @ingroup grp_lifecycle
 @ref Release ֐̃bp[`B ̃}N͂̊֐̃Avbǧďo
 eՂɂB
*/
#define IOMBSEC_Release( psIOMBSEC ) \
	AEEGETPVTBL( (psIOMBSEC), IOMBSEC )->lwIOMBSEC_Release( psIOMBSEC )

/** @ingroup grp_client_certification
 @ref HandleEvent ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBSEC_HandleEvent( psIOMBSEC, eCode, wp, dwp ) \
	AEEGETPVTBL( (psIOMBSEC), IOMBSEC )->HandleEvent( psIOMBSEC, eCode, wp, dwp )

/** @ingroup grp_client_certification
 @ref GetClientCertAndKeyUI ֐̃bp[`B ̃}N͂̊֐̃Avbg
 ďoeՂɂB
*/
#define IOMBSEC_GetClientCertAndKeyUI( psIOMBSEC, pbDNList, lwDNListLen, pfvCallBack, pvUser ) \
	AEEGETPVTBL( (psIOMBSEC), IOMBSEC )->GetClientCertAndKeyUI( psIOMBSEC, pbDNList, lwDNListLen, pfvCallBack, pvUser )


#endif //ndef PREPROCESSING_ONLY

/*==============================================================================

	GLOBAL VARIABLE DECLARATIONS

==============================================================================*/


/*==============================================================================

	FUNCTION DECLARATIONS

==============================================================================*/


#endif /* _IOMBSEC_H */



