// -----------------------------------------------------------------------------
// ISHELL_GetDeviceInfoEx KDDIg
// 2004/11/30 KDDI
// 2004/12/06 KDDI BREW3.1 API-01A-foCX łɂC
// 2005/01/11 KDDI BREW3.1 API-01A-foCX1.0.4łɂC
// 2005/01/25 KDDI ST_KDDI_HISTORY_INCALLyST_KDDI_HISTORY_OUTCALLύX
// 2005/06/23 KDDI BREW3.1 API-01A-foCX1.1.4łɂC

// dlFBREW3.1vdlVF
//             BREW3.1 API-01A-foCX
// -----------------------------------------------------------------------------

/******************************************************************************
//  [PTX-804C]
//	Version	UIQ/TRK	OutLine
//	   0.31	TRK346	PTX-804 BREW-20050530001 NJK R q
//						DeviceC
//	   0.33 		PTX-804 BREW101-KDDISPEC:20050603001 NJK  
//						ISHELL_GetDeviceInfoEx()̕sΉ
//	   0.73 		PTX-804 BREW102-TRK4776:20050725001 NJK  
//						050630-KDDI Extension}[W
//  [PTX-805C]
//	00.10.00 		PTX-805 BREW201-KDDISPEC:20050920001 NJK  X
//						050830-KDDI Extension}[W
//  [PTX-808C]
//	00.11.00 		PTX-808 BREW301-KDDISPEC:20060112001 NJK  
//						060112-KDDI Extension}[W
******************************************************************************/

#ifndef __KDDI_DEVICEINFO_H__
#define __KDDI_DEVICEINFO_H__

#ifndef AEE_DEVICEITEM_USER
#include "aeeshell.h"
#endif	// AEE_DEVICEITEM_USER

#define KDDI_DEVICEITEM_BASE (AEE_DEVICEITEM_USER+0x1000)

#define KDDI_RESERVE000				KDDI_DEVICEITEM_BASE +  0
#define KDDI_CALL_TIME				KDDI_DEVICEITEM_BASE +  1
#define KDDI_CALL_AMOUNT_TIME		KDDI_DEVICEITEM_BASE +  2
#define KDDI_CALL_CHARGE			KDDI_DEVICEITEM_BASE +  3
#define KDDI_CALL_AMOUNT_CHARGE		KDDI_DEVICEITEM_BASE +  4
#define KDDI_RESERVE005				KDDI_DEVICEITEM_BASE +  5
#define KDDI_RESERVE006				KDDI_DEVICEITEM_BASE +  6
#define KDDI_RESERVE007				KDDI_DEVICEITEM_BASE +  7
#define KDDI_RESERVE008				KDDI_DEVICEITEM_BASE +  8
#define KDDI_RESERVE009				KDDI_DEVICEITEM_BASE +  9

#define KDDI_HANDSET_TYPE			KDDI_DEVICEITEM_BASE + 10
#define KDDI_SUBSCRIBER_ID			KDDI_DEVICEITEM_BASE + 11
#define KDDI_INTENSITY				KDDI_DEVICEITEM_BASE + 12
#define KDDI_POWER_SUPPLY_LEVEL		KDDI_DEVICEITEM_BASE + 13
#define KDDI_VOLUME_LEVEL_CMAIL		KDDI_DEVICEITEM_BASE + 14
#define KDDI_VOLUME_LEVEL_EMAIL		KDDI_DEVICEITEM_BASE + 15
#define KDDI_VOLUME_LEVEL_VOICE		KDDI_DEVICEITEM_BASE + 16
#define KDDI_VOLUME_LEVEL_RINGER	KDDI_DEVICEITEM_BASE + 17
#define KDDI_VOLUME_LEVEL_KEY		KDDI_DEVICEITEM_BASE + 18
#define KDDI_RESERVE019				KDDI_DEVICEITEM_BASE + 19

#define KDDI_UI_FONTSIZE_HANDSET	KDDI_DEVICEITEM_BASE + 20
#define KDDI_UI_FONTSIZE_CMAIL		KDDI_DEVICEITEM_BASE + 21
#define KDDI_UI_FONTSIZE_EMAIL		KDDI_DEVICEITEM_BASE + 22
#define KDDI_UI_FONTSIZE_WAP		KDDI_DEVICEITEM_BASE + 23
#define KDDI_UI_BILINGAL			KDDI_DEVICEITEM_BASE + 24
#define KDDI_UI_ISSMARTMODE			KDDI_DEVICEITEM_BASE + 25
#define KDDI_UI_CDMAOFFLINE			KDDI_DEVICEITEM_BASE + 26
#define KDDI_UI_SECRETMODE			KDDI_DEVICEITEM_BASE + 27
#define KDDI_RESERVE028				KDDI_DEVICEITEM_BASE + 28
#define KDDI_UI_EZPG_SCROLL			KDDI_DEVICEITEM_BASE + 29

#define KDDI_UI_LIGHT_NORMAL_TO		KDDI_DEVICEITEM_BASE + 30
#define KDDI_UI_LIGHT_MAIL_TO		KDDI_DEVICEITEM_BASE + 31
#define KDDI_UI_LIGHT_WAP_TO		KDDI_DEVICEITEM_BASE + 32
#define KDDI_UI_LIGHT_OFFTIMER		KDDI_DEVICEITEM_BASE + 33
#define KDDI_RESERVE034				KDDI_DEVICEITEM_BASE + 34
#define KDDI_UI_EZWAP_KEY			KDDI_DEVICEITEM_BASE + 35
#define KDDI_UI_EZMAIL_KEY			KDDI_DEVICEITEM_BASE + 36
#define KDDI_UI_EZ_SCROLLKEY		KDDI_DEVICEITEM_BASE + 37
//[PTX812_KCPCORE_NEU] CuiXinyu Modified 2006/02/14-S-
//#define KDDI_RESERVE038				KDDI_DEVICEITEM_BASE + 38
#define KDDI_UI_ANNUNCIATOR_HEIGHT  	KDDI_DEVICEITEM_BASE + 38
//[PTX812_KCPCORE_NEU] CuiXinyu Modified 2006/02/14-E-
#define KDDI_RESERVE039				KDDI_DEVICEITEM_BASE + 39

#define KDDI_RESTRICT_HANDSET		KDDI_DEVICEITEM_BASE + 40
#define KDDI_RESTRICT_CMAIL			KDDI_DEVICEITEM_BASE + 41
#define KDDI_RESTRICT_EMAIL			KDDI_DEVICEITEM_BASE + 42
#define KDDI_RESTRICT_WAP			KDDI_DEVICEITEM_BASE + 43
#define KDDI_RESTRICT_EZAPP			KDDI_DEVICEITEM_BASE + 44
#define KDDI_RESTRICT_ADDRBOOK		KDDI_DEVICEITEM_BASE + 45
#define KDDI_RESTRICT_ORIGINATION	KDDI_DEVICEITEM_BASE + 46
#define KDDI_RESTRICT_EZAPP_NET		KDDI_DEVICEITEM_BASE + 47
//#define KDDI_RESERVE048				KDDI_DEVICEITEM_BASE + 48 					/*** PTX-804 BREW102 ORG ***/
#define KDDI_RESTRICT_PTM			KDDI_DEVICEITEM_BASE + 48						/*** PTX-804 BREW102 ***/
#define KDDI_RESTRICT_PCSV          KDDI_DEVICEITEM_BASE + 49						/*** PTX-808 BREW301 ***/

#define KDDI_DEV_BLOCKSIZE			KDDI_DEVICEITEM_BASE + 50
#define KDDI_DEV_UITIMEDIFF			KDDI_DEVICEITEM_BASE + 51
#define KDDI_DEV_DISP0_COLORDEPTH	KDDI_DEVICEITEM_BASE + 52
#define KDDI_DEV_DISP0_COLORDEPTH_T	KDDI_DEVICEITEM_BASE + 53
#define KDDI_DEV_DEVCAP_MULTIMEDIA	KDDI_DEVICEITEM_BASE + 54
#define KDDI_DEV_DEVCAP_PDU			KDDI_DEVICEITEM_BASE + 55
#define KDDI_DEV_HANDSETNAME		KDDI_DEVICEITEM_BASE + 56
#define KDDI_DEV_DISPLAY_DPI		KDDI_DEVICEITEM_BASE + 57
#define KDDI_DEV_DISPLAY1_RECT		KDDI_DEVICEITEM_BASE + 58						/*** PTX-804 BREW101 ***/
//#define KDDI_RESERVE059				KDDI_DEVICEITEM_BASE + 59					/*** PTX-804 BREW102 ORG ***/
#define KDDI_DEV_RUIMID_STATE		KDDI_DEVICEITEM_BASE + 59						/*** PTX-804 BREW102 ***/

//#define KDDI_RESERVE060				KDDI_DEVICEITEM_BASE + 60					/*** PTX-804 BREW102 ORG ***/
#define KDDI_DEV_SIDE_CONTROL		KDDI_DEVICEITEM_BASE + 60						/*** PTX-804 BREW102 ***/
//#define KDDI_RESERVE061				KDDI_DEVICEITEM_BASE + 61					/*** PTX-804 BREW102 ORG ***/
#define KDDI_DEV_REMOTE_CONTROL		KDDI_DEVICEITEM_BASE + 61						/*** PTX-804 BREW102 ***/
//[PTX812_KCPCORE_NEU] CuiXinyu Modified 2006/02/14-S-
//#define KDDI_RESERVE062				KDDI_DEVICEITEM_BASE + 62
#define KDDI_DEV_AZIMUTHMAGNET		KDDI_DEVICEITEM_BASE + 62
//[PTX812_KCPCORE_NEU] CuiXinyu Modified 2006/02/14-E-
#define KDDI_RESERVE063				KDDI_DEVICEITEM_BASE + 63
#define KDDI_RESERVE064				KDDI_DEVICEITEM_BASE + 64
#define KDDI_RESERVE065				KDDI_DEVICEITEM_BASE + 65
#define KDDI_RESERVE066				KDDI_DEVICEITEM_BASE + 66
#define KDDI_RESERVE067				KDDI_DEVICEITEM_BASE + 67
#define KDDI_RESERVE068				KDDI_DEVICEITEM_BASE + 68
#define KDDI_RESERVE069				KDDI_DEVICEITEM_BASE + 69



#define KDDI_HISTORY_OUTCALL		KDDI_DEVICEITEM_BASE + 70
#define KDDI_HISTORY_INCALL			KDDI_DEVICEITEM_BASE + 71
#define KDDI_DEVICESTATE_GPSNOTE	KDDI_DEVICEITEM_BASE + 72
//  PTX-804 BREW-20050530001 NJK R q
#define KDDI_IPTRAFFIC_LIMIT		KDDI_DEVICEITEM_BASE + 73
#define KDDI_IPTRAFFIC_CURRENT		KDDI_DEVICEITEM_BASE + 74
//  PTX-804 BREW-20050530001 NJK R q

#define KDDI_LOCKNO_DIGITS          KDDI_DEVICEITEM_BASE + 75						/*** PTX-805 BREW201 ***/
#define KDDI_EZ_BOOKMARK            KDDI_DEVICEITEM_BASE + 76						/*** PTX-805 BREW201 ***/
//[PTX812_KCPCORE_NEU] CuiXinyu Modified 2006/02/14-S-
#define KDDI_ANNUNCIATOR             		KDDI_DEVICEITEM_BASE + 77  
#define KDDI_PUT_CLIPBORAD            		KDDI_DEVICEITEM_BASE + 78  
#define KDDI_RESERVE079				KDDI_DEVICEITEM_BASE + 79
#define KDDI_RESERVE080				KDDI_DEVICEITEM_BASE + 80
#define KDDI_RESERVE081				KDDI_DEVICEITEM_BASE + 81
#define KDDI_RESERVE082				KDDI_DEVICEITEM_BASE + 82
#define KDDI_RESERVE083				KDDI_DEVICEITEM_BASE + 83
#define KDDI_RESERVE084				KDDI_DEVICEITEM_BASE + 84
#define KDDI_RESERVE085				KDDI_DEVICEITEM_BASE + 85
#define KDDI_RESERVE086				KDDI_DEVICEITEM_BASE + 86
#define KDDI_RESERVE087				KDDI_DEVICEITEM_BASE + 87
#define KDDI_RESERVE088				KDDI_DEVICEITEM_BASE + 88
#define KDDI_RESERVE089				KDDI_DEVICEITEM_BASE + 89
#define KDDI_RESERVE090				KDDI_DEVICEITEM_BASE + 90
#define KDDI_RESERVE091				KDDI_DEVICEITEM_BASE + 91
#define KDDI_RESERVE092				KDDI_DEVICEITEM_BASE + 92
#define KDDI_RESERVE093				KDDI_DEVICEITEM_BASE + 93
#define KDDI_RESERVE094				KDDI_DEVICEITEM_BASE + 94
#define KDDI_RESERVE095				KDDI_DEVICEITEM_BASE + 95
#define KDDI_RESERVE096				KDDI_DEVICEITEM_BASE + 96
#define KDDI_RESERVE097				KDDI_DEVICEITEM_BASE + 97
#define KDDI_RESERVE098				KDDI_DEVICEITEM_BASE + 98
#define KDDI_RESERVE099				KDDI_DEVICEITEM_BASE + 99
#define KDDI_M1_TALKTIMEDISP			KDDI_DEVICEITEM_BASE + 100
#define KDDI_RESERVE101				KDDI_DEVICEITEM_BASE + 101
#define KDDI_RESERVE102				KDDI_DEVICEITEM_BASE + 102
#define KDDI_RESERVE103				KDDI_DEVICEITEM_BASE + 103
#define KDDI_RESERVE104				KDDI_DEVICEITEM_BASE + 104
#define KDDI_RESERVE105				KDDI_DEVICEITEM_BASE + 105
#define KDDI_RESERVE106				KDDI_DEVICEITEM_BASE + 106
#define KDDI_RESERVE107				KDDI_DEVICEITEM_BASE + 107
#define KDDI_RESERVE108				KDDI_DEVICEITEM_BASE + 108
#define KDDI_RESERVE109				KDDI_DEVICEITEM_BASE + 109
#define KDDI_RESERVE110				KDDI_DEVICEITEM_BASE + 110
#define KDDI_RESERVE111				KDDI_DEVICEITEM_BASE + 111
#define KDDI_RESERVE112				KDDI_DEVICEITEM_BASE + 112
#define KDDI_RESERVE113				KDDI_DEVICEITEM_BASE + 113
#define KDDI_RESERVE114				KDDI_DEVICEITEM_BASE + 114
#define KDDI_RESERVE115				KDDI_DEVICEITEM_BASE + 115
#define KDDI_RESERVE116				KDDI_DEVICEITEM_BASE + 116
#define KDDI_RESERVE117				KDDI_DEVICEITEM_BASE + 117
#define KDDI_RESERVE118				KDDI_DEVICEITEM_BASE + 118
#define KDDI_RESERVE119				KDDI_DEVICEITEM_BASE + 119
#define KDDI_RESERVE120				KDDI_DEVICEITEM_BASE + 120
#define KDDI_RESERVE121				KDDI_DEVICEITEM_BASE + 121
#define KDDI_RESERVE122				KDDI_DEVICEITEM_BASE + 122
#define KDDI_RESERVE123				KDDI_DEVICEITEM_BASE + 123
#define KDDI_RESERVE124				KDDI_DEVICEITEM_BASE + 124
#define KDDI_RESERVE125				KDDI_DEVICEITEM_BASE + 125
#define KDDI_RESERVE126				KDDI_DEVICEITEM_BASE + 126
#define KDDI_RESERVE127				KDDI_DEVICEITEM_BASE + 127
#define KDDI_RESERVE128				KDDI_DEVICEITEM_BASE + 128
#define KDDI_RESERVE129				KDDI_DEVICEITEM_BASE + 129
#define KDDI_RESERVE130				KDDI_DEVICEITEM_BASE + 130
#define KDDI_RESERVE131				KDDI_DEVICEITEM_BASE + 131
#define KDDI_RESERVE132				KDDI_DEVICEITEM_BASE + 132
#define KDDI_RESERVE133				KDDI_DEVICEITEM_BASE + 133
#define KDDI_RESERVE134				KDDI_DEVICEITEM_BASE + 134
#define KDDI_RESERVE135				KDDI_DEVICEITEM_BASE + 135
#define KDDI_RESERVE136				KDDI_DEVICEITEM_BASE + 136
#define KDDI_RESERVE137				KDDI_DEVICEITEM_BASE + 137
#define KDDI_RESERVE138				KDDI_DEVICEITEM_BASE + 138
#define KDDI_RESERVE139				KDDI_DEVICEITEM_BASE + 139
#define KDDI_M4_TELL_CALLER_ID		KDDI_DEVICEITEM_BASE + 140
#define KDDI_RESERVE141				KDDI_DEVICEITEM_BASE + 141
#define KDDI_RESERVE142				KDDI_DEVICEITEM_BASE + 142
#define KDDI_RESERVE143				KDDI_DEVICEITEM_BASE + 143
#define KDDI_RESERVE144				KDDI_DEVICEITEM_BASE + 144
#define KDDI_RESERVE145				KDDI_DEVICEITEM_BASE + 145
#define KDDI_RESERVE146				KDDI_DEVICEITEM_BASE + 146
#define KDDI_RESERVE147				KDDI_DEVICEITEM_BASE + 147
#define KDDI_RESERVE148				KDDI_DEVICEITEM_BASE + 148
#define KDDI_RESERVE149				KDDI_DEVICEITEM_BASE + 149
#define KDDI_RESERVE150				KDDI_DEVICEITEM_BASE + 150
//[PTX812_KCPCORE_NEU] CuiXinyu Modified 2006/02/14-E-

/*==============================================================================
KDDI_HISTORY_XXp`
==============================================================================*/

// -----------------------------------------------------------------------------
// MXe[^XFnIncall_states
// -----------------------------------------------------------------------------
#define KDDI_INCALL_STATES_NORMAL				0	// b
#define KDDI_INCALL_STATES_MISSED				1	// s
#define KDDI_INCALL_STATES_SHORT				2	// ZbM
#define KDDI_INCALL_STATES_DENY					3	// M

// -----------------------------------------------------------------------------
// ԍʒmRFnReasonOfNoNumber
// -----------------------------------------------------------------------------
#define KDDI_REASEONOFNONUMBER_NONE				0	// ʒmL
#define KDDI_REASEONOFNONUMBER_USER				1	// ʒmݒ
#define KDDI_REASEONOFNONUMBER_CONFLICT			2	// T[rX
#define KDDI_REASEONOFNONUMBER_PUBLIC_TEL		3	// Odb
#define KDDI_REASEONOFNONUMBER_NOT_AVAILABLE	4	// T[rXps
#define KDDI_REASEONOFNONUMBER_SLUMDOWN			5	// X_E

// -----------------------------------------------------------------------------
// 擾lF MB
// ȉ̃oȂST_KDDI_HISTORY_INCALL\̂̔zƂĕԋp
// TCYF  sizeof(ST_KDDI_HISTORY_INCALL)~M
// -----------------------------------------------------------------------------
typedef struct _ST_KDDI_HISTORY_INCALL
{
	char	szHistory[14+2];	// M(YYYYMMDDHHMMSS`ASCIIZ)
	uint32	dwCallDuration;		// ʘb(b)
	char 	szNumber[36+2];		// Mdbԍ(ASCIIZ)Bʒm̏ꍇ\0
	char	szName[24+2];		// szNumberɑΉo^iASCIIZjBo^̏ꍇ\0
	int		nIncall_states;		// MXe[^X
	int		nReasonOfNoNumber;	// ԍʒmR
} ST_KDDI_HISTORY_INCALL;

// -----------------------------------------------------------------------------
// 擾lF MB
// ȉ̃oȂST_KDDI_HISTORY_OUTCALL\̂̔zƂĕԋp
// TCYF  sizeof(ST_KDDI_HISTORY_OUTCALL)~M
// -----------------------------------------------------------------------------
typedef struct _ST_KDDI_HISTORY_OUTCALL
{
	char	szHistory[14+2];	// M(YYYYMMDDHHMMSS`ASCIIZ)
	uint32	dwCallDuration;		// ʘb(b)
	char 	szNumber[36+2];		// Mdbԍ(ASCIIZ)B
	char	szName[24+2];		// szNumberɑΉo^iASCIIZ)Bo^̏ꍇ\0
} ST_KDDI_HISTORY_OUTCALL;


#endif  // __KDDI_DEVICEINFO_H__
